local AceConfigDialog = LibStub("AceConfigDialog-3.0")
local AceConfig = LibStub("AceConfig-3.0")

SC_OptionsTable_Sound = {
	name = SC_LANG_SOUND,
	handler = SliceCommander,
	type = "group",
	args = {--Sound settings
		headerSndSoundSetting = {--Slice and Dice
			order = 1,
			name = "Slice and Dice",
			type = "header"
		},
		Tick3 = {--Alert - 3 sec
			order = 2,
			name = "Alert - 3 sec",
			desc = "Alert 3 secondes before fade",
			type = "select",
			values = function()
				return SliceCommander:ConfigSoundMenuInit("Tick")
			end,
			set = function(info,val)
				SliceCommander:SoundTest(val)
				SliceCommander_Save.Tick3 = val
			end,
			get = function(info) return SliceCommander_Save.Tick3 end
		},
		Tick2 = {--Alert - 2 sec
			order = 4,
			name = "Alert - 2 sec",
			desc = "Alert 2 secondes before fade",
			type = "select",
			values = function()
				return SliceCommander:ConfigSoundMenuInit("Tick")
			end,
			set = function(info,val)
				SliceCommander:SoundTest(val)
				SliceCommander_Save.Tick2 = val
			end,
			get = function(info) return SliceCommander_Save.Tick2 end
		},
		Tick1 = {--Alert - 1 sec
			order = 6,
			name = "Alert - 1 sec",
			desc = "Alert 1 secondes before fade",
			type = "select",
			values = function()
				return SliceCommander:ConfigSoundMenuInit("Tick")
			end,
			set = function(info,val)
				SliceCommander:SoundTest(val)
				SliceCommander_Save.Tick1 = val
			end,
			get = function(info) return SliceCommander_Save.Tick1 end
		},
		Apply3 = {--Refresh - 3 sec
			order = 3,
			name = "Refresh - 3 sec",
			desc = "Refresh 3 secondes before fade",
			type = "select",
			values = function()
				return SliceCommander:ConfigSoundMenuInit("Apply")
			end,
			set = function(info,val)
				SliceCommander:SoundTest(val)
				SliceCommander_Save.Apply3 = val
			end,
			get = function(info) return SliceCommander_Save.Apply3 end
		},
		Apply2 = {--Refresh - 2 sec
			order = 5,
			name = "Refresh - 2 sec",
			desc = "Refresh 2 secondes before fade",
			type = "select",
			values = function()
				return SliceCommander:ConfigSoundMenuInit("Apply")
			end,
			set = function(info,val)
				SliceCommander:SoundTest(val)
				SliceCommander_Save.Apply2 = val
			end,
			get = function(info) return SliceCommander_Save.Apply2 end
		},
		Apply1 = {--Refresh - 1 sec
			order = 7,
			name = "Refresh - 1 sec",
			desc = "Refresh 1 secondes before fade",
			type = "select",
			values = function()
				return SliceCommander:ConfigSoundMenuInit("Apply")
			end,
			set = function(info,val)
				SliceCommander:SoundTest(val)
				SliceCommander_Save.Apply1 = val
			end,
			get = function(info) return SliceCommander_Save.Apply1 end
		},
		Fail = {--Faillure
			order = 8,
			name = "Faillure",
			desc = "The refresh failled",
			type = "select",
			values = function()
				return SliceCommander:ConfigSoundMenuInit("Fail")
			end,
			set = function(info,val)
				SliceCommander:SoundTest(val)
				SliceCommander_Save.Fail = val
			end,
			get = function(info) return SliceCommander_Save.Fail end
		},
		
		Applied = {--Applied
			order = 9,
			name = "Applied",
			desc = "Slice and Dice is applied",
			type = "select",
			values = function()
				return SliceCommander:ConfigSoundMenuInit("Apply")
			end,
			set = function(info,val)
				SliceCommander:SoundTest(val)
				SliceCommander_Save.Applied = val
			end,
			get = function(info) return SliceCommander_Save.Applied end
		},
		Expire = {--Expire
			order = 10,
			name = "Expired",
			desc = "Slice and Dice buff expire",
			type = "select",
			values = function()
				return SliceCommander:ConfigSoundMenuInit("Fail")
			end,
			set = function(info,val)
				SliceCommander:SoundTest(val)
				SliceCommander_Save.Expire = val
			end,
			get = function(info) return SliceCommander_Save.Expire end
		},
		headerRupSoundSetting = {--Rupture
			order = 11,
			name = "Rupture",
			type = "header"
		},
		RUP_Alert = {--Alert
			order = 12,
			name = "Alert",
			desc = "Alert 3, 2 and 1 secondes before fade",
			type = "select",
			values = function()
				return SliceCommander:ConfigSoundMenuInit("Tick")
			end,
			set = function(info,val)
				SliceCommander:SoundTest(val)
				SliceCommander_Save.RUP_Alert = val
			end,
			get = function(info) return SliceCommander_Save.RUP_Alert end
		},
		RUP_Refresh3 = {--Refresh - 3 sec
			order = 13,
			name = "Refresh - 3 sec",
			desc = "Refresh 3 secondes before fade",
			type = "select",
			values = function()
				return SliceCommander:ConfigSoundMenuInit("Apply")
			end,
			set = function(info,val)
				SliceCommander:SoundTest(val)
				SliceCommander_Save.RUP_Refresh3 = val
			end,
			get = function(info) return SliceCommander_Save.RUP_Refresh3 end
		},
		RUP_Refresh2 = {--Refresh - 2 sec
			order = 15,
			name = "Refresh - 2 sec",
			desc = "Refresh 2 secondes before fade",
			type = "select",
			values = function()
				return SliceCommander:ConfigSoundMenuInit("Apply")
			end,
			set = function(info,val)
				SliceCommander:SoundTest(val)
				SliceCommander_Save.RUP_Refresh2 = val
			end,
			get = function(info) return SliceCommander_Save.RUP_Refresh2 end
		},
		RUP_Refresh1 = {--Refresh - 1 sec
			order = 17,
			name = "Refresh - 1 sec",
			desc = "Refresh 1 secondes before fade",
			type = "select",
			values = function()
				return SliceCommander:ConfigSoundMenuInit("Apply")
			end,
			set = function(info,val)
				SliceCommander:SoundTest(val)
				SliceCommander_Save.RUP_Refresh1 = val
			end,
			get = function(info) return SliceCommander_Save.RUP_Refresh1 end
		},
		RUP_Fail = {--Faillure
			order = 14,
			name = "Faillure",
			desc = "The refresh failled",
			type = "select",
			values = function()
				return SliceCommander:ConfigSoundMenuInit("Fail")
			end,
			set = function(info,val)
				SliceCommander:SoundTest(val)
				SliceCommander_Save.RUP_Fail = val
			end,
			get = function(info) return SliceCommander_Save.RUP_Fail end
		},
		RUP_Applied = {--Applied
			order = 16,
			name = "Applied",
			desc = "Rupture is applied",
			type = "select",
			values = function()
				return SliceCommander:ConfigSoundMenuInit("Apply")
			end,
			set = function(info,val)
				SliceCommander:SoundTest(val)
				SliceCommander_Save.RUP_Applied = val
			end,
			get = function(info) return SliceCommander_Save.RUP_Applied end
		},
		RUP_Expire = {--Expire
			order = 18,
			name = "Expired",
			desc = "Rupture debuff expire",
			type = "select",
			values = function()
				return SliceCommander:ConfigSoundMenuInit("Fail")
			end,
			set = function(info,val)
				SliceCommander:SoundTest(val)
				SliceCommander_Save.RUP_Expire = val
			end,
			get = function(info) return SliceCommander_Save.RUP_Expire end
		},
	}
}

SC_OptionsTable_DisplayTimer = {
	name = SC_DISPLAY_SETTINGS,
	handler = SliceCommander,
	type = "group",
	args = {--Display setting
		displayDescription = {
			order = 0,
			name = "Each bar have to have a different position. If you want to have a bar on the top of the energy bar you have to use negative index. Positive index is used to position bar at the bottom.",
			fontSize = "medium",
			type = "description"
		},
		headerEnergySetting = {--Combo Point Settings
			order = 1,
			name = "Energy bar Settings",
			type = "header"
		},
		HideEnergy = {--Hide Energy
			order = 2,
			name = "Hide Energy bar",
			desc = "Hide the Energy bar",
			type = "toggle",
			set = function(info,val)
				if val then
					VTimerEnergy:Hide()
				else
					VTimerEnergy:Show()
				end
				SliceCommander_Save.HideEnergy = val
			end,
			get = function(info) return SliceCommander_Save.HideEnergy end
		},
		EnergyTrans = {--Energy bar transparancy
			order = 3,
			name = "Transparency (Full)",
			desc = "The fade out value of the energy bar when it is full.",
			type = "range",
			min = 0,
			max = 100,
			step = 1,
			bigStep = 1,
			set = function(info,val)
				SliceCommander:SetPoisonTransparency(val)
				SliceCommander_Save.EnergyTrans = val
			end,
			get = function(info) return SliceCommander_Save.EnergyTrans end,
			isPercent = false
		},
		Energy1 = {--Energy Marker 1
			order = 4,
			name = "Energy Marker 1",
			type = "range",
			min = 0,
			max = 120,
			step = 1,
			bigStep = 1,
			set = function(info,val)
				if val > UnitManaMax("player") then
					val = UnitManaMax("player")
				end
				SliceCommander_Save.Energy1 = val
				SliceCommander:Config_OtherVars()
			end,
			get = function(info) return SliceCommander_Save.Energy1 end,
			isPercent = false
		},
		Energy2 = {--Energy Marker 2
			order = 5,
			name = "Energy Marker 2",
			type = "range",
			min = 0,
			max = 120,
			step = 1,
			bigStep = 1,
			set = function(info,val)
				if val > UnitManaMax("player") then
					val = UnitManaMax("player")
				end
				SliceCommander_Save.Energy2 = val
				SliceCommander:Config_OtherVars()
			end,
			get = function(info) return SliceCommander_Save.Energy2 end,
			isPercent = false
		},
		Energy3 = {--Energy Marker 3
			order = 6,
			name = "Energy Marker 3",
			type = "range",
			min = 0,
			max = 120,
			step = 1,
			bigStep = 1,
			set = function(info,val)
				if val > UnitManaMax("player") then
					val = UnitManaMax("player")
				end
				SliceCommander_Save.Energy3 = val
				SliceCommander:Config_OtherVars()
			end,
			get = function(info) return SliceCommander_Save.Energy3 end,
			isPercent = false
		},
		headerDPSetting = {--Poison bar Settings
			order = 7,
			name = "Poison bar Settings",
			type = "header"
		},
		DPBarShow = {--Show Poison
			order = 8,
			name = "Show Poison bar",
			desc = "Display the Poison timer bar",
			type = "toggle",
			set = function(info,val)
				SliceCommander_Save.display.DP = val
			end,
			get = function(info) return SliceCommander_Save.display.DP end
		},
		PosDP = {--Poison position
			order = 9,
			name = "Poison bar position",
			desc = "The place where to display the Poison bar",
			type = "select",
			values = function()
				returnArray = {}
				for key = -15, 15, 1 do
					returnArray[key] = key
				end
				return returnArray
			end,
			set = function(info,val)
				SliceCommander_Save.Pos.DP = val
			end,
			get = function(info) return SliceCommander_Save.Pos.DP end
		},
		EnvenomShow = {--Show Envenom
			order = 10,
			name = "Show envenom buff",
			desc = "The timer bar in default will display the timer of deadly poison on the target.",
			type = "toggle",
			set = function(info,val)
				SliceCommander_Save.EnvenomShow = val
			end,
			get = function(info) return SliceCommander_Save.EnvenomShow end
		},
		PosENV = {--Poison position
			order = 9,
			name = "Envenom bar position",
			desc = "The place where to display the Envenom bar",
			type = "select",
			values = function()
				returnArray = {}
				for key = -15, 15, 1 do
					returnArray[key] = key
				end
				return returnArray
			end,
			set = function(info,val)
				SliceCommander_Save.Pos.ENV = val
			end,
			get = function(info) return SliceCommander_Save.Pos.ENV end
		},
		PoisonShow = {--Show Poison weapon enchant
			order = 11,
			name = "Show poison weapon enchant",
			desc = "Display two thin poison bar timer on the energy bar corresponding of each temporary enchant on each weapon.",
			type = "toggle",
			set = function(info,val)
				SliceCommander_Save.display.Poison = val
			end,
			get = function(info) return SliceCommander_Save.display.Poison end
		},
		PoisonTransparencyShow = {--Show Poison weapon enchant
			order = 12,
			name = "Disable energy bar fade out",
			desc = "Disable energy bar and poison bar fade out when poison on weapon(s) is up",
			type = "toggle",
			set = function(info,val)
				SliceCommander_Save.PoisonTransparencyShow = val
			end,
			get = function(info) return SliceCommander_Save.PoisonTransparencyShow end
		},
		headerVendettaSetting = {--Vendetta Settings
			order = 101,
			name = "Vendetta Settings",
			type = "header"
		},
		VenBarShow = {--Show vendetta
			order = 102,
			name = "Show vendetta bar",
			desc = "Display the vendetta timer bar",
			type = "toggle",
			set = function(info,val)
				SliceCommander_Save.display.VEN = val
			end,
			get = function(info) return SliceCommander_Save.display.VEN end
		},
		PosVEN = {--Vendetta position
			order = 103,
			name = "Vendetta bar position",
			desc = "The place where to display the vendetta bar",
			type = "select",
			values = function()
				returnArray = {}
				for key = -15, 15, 1 do
					returnArray[key] = key
				end
				return returnArray
			end,
			set = function(info,val)
				SliceCommander_Save.Pos.VEN = val
				SliceCommander_Save.Pos.VENCD = val
			end,
			get = function(info) return SliceCommander_Save.Pos.VEN end
		},
		headerToTSetting = {--Tricks of the Trade Settings
			order = 104,
			name = "Tricks of the Trade Settings",
			type = "header"
		},
		TotTBarShow = {--Show ToT
			order = 105,
			name = "Show Tricks of the Trade bar",
			desc = "Display the Tricks of the Trade timer bar",
			type = "toggle",
			set = function(info,val)
				SliceCommander_Save.display.ToT = val
			end,
			get = function(info) return SliceCommander_Save.display.ToT end
		},
		PosToT = {--ToT position
			order = 106,
			name = "Tricks of the Trade bar position",
			desc = "The place where to display the Tricks of the Trade bar",
			type = "select",
			values = function()
				returnArray = {}
				for key = -15, 15, 1 do
					returnArray[key] = key
				end
				return returnArray
			end,
			set = function(info,val)
				SliceCommander_Save.Pos.ToT = val
			end,
			get = function(info) return SliceCommander_Save.Pos.ToT end
		},
		headerRecSetting = {--Recuperate Settings
			order = 110,
			name = "Recuperate Settings",
			type = "header"
		},
		RECBarShow = {--Show Recuperate
			order = 111,
			name = "Show Recuperate bar",
			desc = "Display the Recuperate timer bar",
			type = "toggle",
			set = function(info,val)
				SliceCommander_Save.display.REC = val
			end,
			get = function(info) return SliceCommander_Save.display.REC end
		},
		PosREC = {--Recuperate position
			order = 112,
			name = "Recuperate bar position",
			desc = "The place where to display the Recuperate bar",
			type = "select",
			values = function()
				returnArray = {}
				for key = -15, 15, 1 do
					returnArray[key] = key
				end
				return returnArray
			end,
			set = function(info,val)
				SliceCommander_Save.Pos.REC = val
			end,
			get = function(info) return SliceCommander_Save.Pos.REC end
		},
		headerKSSetting = {--Stun bar Settings
			order = 113,
			name = "Kidney shot bar Settings",
			type = "header"
		},
		KSBarShow = {--Show Stun
			order = 114,
			name = "Kidney shot bar",
			desc = "Display the Kidney shot timer bar",
			type = "toggle",
			set = function(info,val)
				SliceCommander_Save.display.KS = val
			end,
			get = function(info) return SliceCommander_Save.display.KS end
		},
		PosKS = {--Stun position
			order = 115,
			name = "Kidney shot bar position",
			desc = "The place where to display the Kidney shot bar",
			type = "select",
			values = function()
				returnArray = {}
				for key = -15, 15, 1 do
					returnArray[key] = key
				end
				return returnArray
			end,
			set = function(info,val)
				SliceCommander_Save.Pos.KS = val
			end,
			get = function(info) return SliceCommander_Save.Pos.KS end
		},
		headerCSSetting = {--Stun bar Settings
			order = 116,
			name = "Cheap shot bar Settings",
			type = "header"
		},
		CSBarShow = {--Show Stun
			order = 117,
			name = "Show Cheap shot bar",
			desc = "Display the Cheap shot timer bar",
			type = "toggle",
			set = function(info,val)
				SliceCommander_Save.display.CS = val
			end,
			get = function(info) return SliceCommander_Save.display.CS end
		},
		PosCS = {--Stun position
			order = 118,
			name = "Cheap shot bar position",
			desc = "The place where to display the Cheap shot bar",
			type = "select",
			values = function()
				returnArray = {}
				for key = -15, 15, 1 do
					returnArray[key] = key
				end
				return returnArray
			end,
			set = function(info,val)
				SliceCommander_Save.Pos.CS = val
			end,
			get = function(info) return SliceCommander_Save.Pos.CS end
		},
		headerRupSetting = {--Blood Settings
			order = 121,
			name = "Rupture bar Settings",
			type = "header"
		},
		RupBarShow = {--Show Blood
			order = 122,
			name = "Show Rupture bar",
			desc = "Display the Blood timer bar",
			type = "toggle",
			set = function(info,val)
				SliceCommander_Save.display.RUP = val
			end,
			get = function(info) return SliceCommander_Save.display.RUP end
		},
		PosRUP = {--Blood position
			order = 123,
			name = "Rupture bar position",
			desc = "The place where to display the Rupture bar",
			type = "select",
			values = function()
				returnArray = {}
				for key = -15, 15, 1 do
					returnArray[key] = key
				end
				return returnArray
			end,
			set = function(info,val)
				SliceCommander_Save.Pos.RUP = val
			end,
			get = function(info) return SliceCommander_Save.Pos.RUP end
		},
		headerGarSetting = {--Blood Settings
			order = 124,
			name = "Garrote bar Settings",
			type = "header"
		},
		GarBarShow = {--Show Blood
			order = 125,
			name = "Show Garrote bar",
			desc = "Display the Garrote timer bar",
			type = "toggle",
			set = function(info,val)
				SliceCommander_Save.display.GAR = val
			end,
			get = function(info) return SliceCommander_Save.display.GAR end
		},
		PosGAR = {--Blood position
			order = 126,
			name = "Garrote bar position",
			desc = "The place where to display the Garrote bar",
			type = "select",
			values = function()
				returnArray = {}
				for key = -15, 15, 1 do
					returnArray[key] = key
				end
				return returnArray
			end,
			set = function(info,val)
				SliceCommander_Save.Pos.GAR = val
			end,
			get = function(info) return SliceCommander_Save.Pos.GAR end
		},
		headerSndSetting = {--Slice and Dice Settings
			order = 127,
			name = "Slice and Dice Settings",
			type = "header"
		},
		SnDBarShow = {--Show Slice and Dice
			order = 128,
			name = "Show Slice and Dice bar",
			desc = "Display the Slice and Dice timer bar",
			type = "toggle",
			set = function(info,val)
				SliceCommander_Save.display.SnD = val
			end,
			get = function(info) return SliceCommander_Save.display.SnD end
		},
		PosSnD = {--Slice and Dice position
			order = 129,
			name = "Slice and Dice bar position",
			desc = "The place where to display the Slice and Dice bar",
			type = "select",
			values = function()
				returnArray = {}
				for key = -15, 15, 1 do
					returnArray[key] = key
				end
				return returnArray
			end,
			set = function(info,val)
				SliceCommander_Save.Pos.SnD = val
			end,
			get = function(info) return SliceCommander_Save.Pos.SnD end
		},
		headerCPSetting = {--Combo Point Settings
			order = 130,
			name = "Combo Point bar Settings",
			type = "header"
		},
		CPBarShow = {--Show Combo Point
			order = 131,
			name = "Show Combo Point bar",
			desc = "Display the Combo Point timer bar",
			type = "toggle",
			set = function(info,val)
				SliceCommander_Save.display.CP = val
			end,
			get = function(info) return SliceCommander_Save.display.CP end
		},
		PosCP = {--Combo Point position
			order = 132,
			name = "Combo Point bar position",
			desc = "The place where to display the Combo Point bar",
			type = "select",
			values = function()
				returnArray = {}
				for key = -15, 15, 1 do
					returnArray[key] = key
				end
				return returnArray
			end,
			set = function(info,val)
				SliceCommander_Save.Pos.CP = val
			end,
			get = function(info) return SliceCommander_Save.Pos.CP end
		},
		headerThreatSetting = {--Threat Settings
			order = 133,
			name = "Threat bar Settings",
			type = "header"
		},
		THREATBarShow = {--Show Threat
			order = 134,
			name = "Show Threat bar",
			desc = "Display the Threat bar",
			type = "toggle",
			set = function(info,val)
				SliceCommander_Save.display.THREAT = val
			end,
			get = function(info) return SliceCommander_Save.display.THREAT end
		},
		PosTHREAT = {--Threat position
			order = 135,
			name = "Threat bar position",
			desc = "The place where to display the Threat bar",
			type = "select",
			values = function()
				returnArray = {}
				for key = -15, 15, 1 do
					returnArray[key] = key
				end
				return returnArray
			end,
			set = function(info,val)
				SliceCommander_Save.Pos.THREAT = val
			end,
			get = function(info) return SliceCommander_Save.Pos.THREAT end
		},
		ThreatGroupOnly = {--Show Threat bar only in group
			order = 136,
			name = "Threat bar only in group",
			desc = "Display the Threat bar only if you are in a group or a raid",
			type = "toggle",
			set = function(info,val)
				SliceCommander_Save.ThreatGroupOnly = val
			end,
			get = function(info) return SliceCommander_Save.ThreatGroupOnly end
		},
		headerARSetting = {--Adrenaline rush Settings
			order = 137,
			name = "Adrenaline Rush Settings",
			type = "header"
		},
		ARBarShow = {--Show Adrenaline rush
			order = 138,
			name = "Show Adrenaline Rush bar",
			desc = "Display the Adrenaline rush timer bar",
			type = "toggle",
			set = function(info,val)
				SliceCommander_Save.display.AR = val
			end,
			get = function(info) return SliceCommander_Save.display.AR end
		},
		PosAR = {--Adrenaline rush position
			order = 139,
			name = "Adrenaline rush bar position",
			desc = "The place where to display the Adrenaline rush bar",
			type = "select",
			values = function()
				returnArray = {}
				for key = -15, 15, 1 do
					returnArray[key] = key
				end
				return returnArray
			end,
			set = function(info,val)
				SliceCommander_Save.Pos.AR = val
				SliceCommander_Save.Pos.ARCD = val
			end,
			get = function(info) return SliceCommander_Save.Pos.AR end
		},
		ARCDBarShow = {--Show Adrenaline rush CD
			order = 140,
			name = "Show Adrenaline Rush bar CD",
			desc = "Display the Adrenaline rush cooldown bar",
			type = "toggle",
			set = function(info,val)
				SliceCommander_Save.display.ARCD = val
			end,
			get = function(info) return SliceCommander_Save.display.ARCD end
		},
		ARMarioMod = {--Enable Mario mod
			order = 141,
			name = "Enable Mario mod",
			desc = "Enable mario start music during Adrenaline rush buff",
			type = "toggle",
			set = function(info,val)
				SliceCommander_Save.ARMarioMod = val
			end,
			get = function(info) return SliceCommander_Save.ARMarioMod end
		},
		headerEASetting = {--Expose Armor Settings
			order = 151,
			name = "Expose Armor Settings",
			type = "header"
		},
		EABarShow = {--Show EA
			order = 152,
			name = "Show Expose Armor bar",
			desc = "Display the Expose Armor timer bar",
			type = "toggle",
			set = function(info,val)
				SliceCommander_Save.display.EA = val
			end,
			get = function(info) return SliceCommander_Save.display.EA end
		},
		PosEA = {--EA position
			order = 153,
			name = "Expose Armor bar position",
			desc = "The place where to display the Expose Armor bar",
			type = "select",
			values = function()
				returnArray = {}
				for key = -15, 15, 1 do
					returnArray[key] = key
				end
				return returnArray
			end,
			set = function(info,val)
				SliceCommander_Save.Pos.EA = val
			end,
			get = function(info) return SliceCommander_Save.Pos.EA end
		},
		headerFESetting = {--Feint Settings
			order = 161,
			name = "Feint Settings",
			type = "header"
		},
		FEBarShow = {--Show Feint
			order = 162,
			name = "Show Feint bar",
			desc = "Display the Feint timer bar",
			type = "toggle",
			set = function(info,val)
				SliceCommander_Save.display.FE = val
			end,
			get = function(info) return SliceCommander_Save.display.FE end
		},
		PosFE = {--Feint position
			order = 163,
			name = "Feint bar position",
			desc = "The place where to display the Feint bar",
			type = "select",
			values = function()
				returnArray = {}
				for key = -15, 15, 1 do
					returnArray[key] = key
				end
				return returnArray
			end,
			set = function(info,val)
				SliceCommander_Save.Pos.FE = val
				SliceCommander_Save.Pos.FECD = val
			end,
			get = function(info) return SliceCommander_Save.Pos.FE end
		},
	}
}

SC_OptionsTable = {
	name = "SliceCommander",
	handler = SliceCommander,
	type = "group",
	args = {--SliceCommander
		IsLocked = {--Lock
			order = 1,
			name = "Lock",
			desc = "Disable Left Click to Move",
			type = "toggle",
			set = function(info,val)
				SliceCommander:LockCkecked(val)
			end,
			get = function(info) return SliceCommander_Save.IsLocked end
		},
		FullTimer = {--Full timer
			order = 2,
			name = "Full Timer",
			desc = "Make timer full bar duration",
			type = "toggle",
			set = function(info,val) SliceCommander_Save.FullTimer = val end,
			get = function(info) return SliceCommander_Save.FullTimer end
		},
		PadLatency = {--Latency
			order = 3,
			name = "Enable Latency",
			desc = "Pad Alerts with Latency",
			type = "toggle",
			set = function(info,val) SliceCommander_Save.PadLatency = val end,
			get = function(info) return SliceCommander_Save.PadLatency end
		},
		SpellText = {--Spell text
			order = 4,
			name = "Spell Text",
			desc = "Enable spell text on bars",
			type = "toggle",
			set = function(info,val) SliceCommander_Save.SpellText = val end,
			get = function(info) return SliceCommander_Save.SpellText end
		},
		SoundCombat = {--Disable sound out of combat
			order = 5,
			name = "Sound Combat",
			desc = "Disable sounds out of combat",
			type = "toggle",
			set = function(info,val) SliceCommander_Save.SoundCombat = val end,
			get = function(info) return SliceCommander_Save.SoundCombat end
		},
		headerDisplaySetting = {--CDisplay Setting
			order = 6,
			name = "Display Setting",
			type = "header"
		},
		BarTexture = {--Texture
			order = 7,
			name = "Bar Texture",
			desc = "Bar Texture for timer and energy",
			type = "select",
			values = function()
				returnArray = {}
				for key, value in pairs(SliceCommander_BarTextures) do 
					returnArray[key] = key
				end
				return returnArray
			end,
			set = function(info,val)
				SliceCommander_Save.BarTexture = val
				SliceCommander:Config_RetextureBars(SliceCommander:BarTexture())
			end,
			get = function(info) return SliceCommander_Save.BarTexture end
		},
		Width = {--Width
			order = 9,
			name = "Width",
			desc = "Bar Width. If the frame is blury or some texture are shity and you currently play on multiple screen. You should use the command /sc eyefinity x. X is the number of screen you play on.",
			type = "range",
			min = 125,
			max = 300,
			step = 1,
			bigStep = 5,
			set = function(info,val)
				SliceCommander_Save.Width = val
				if SliceCommander_Save.skin then
					SliceCommander:ApplySkin(false)
				end
				SliceCommander:SetWidth(val)
				if SliceCommander_Save.skin then
					SliceCommander:ApplySkin(true)
				end
				
			end,
			get = function(info) return SliceCommander_Save.Width end,
			isPercent = false
		},
		EnergyHeight = {--Energy bar height
			order = 10,
			name = "Energy Height",
			desc = "EnergyBar Height",
			type = "range",
			min = 1,
			max = 40,
			step = 1,
			bigStep = 1,
			set = function(info,val)
				SliceCommander_Save.EnergyHeight = val
				SliceCommander:SetEnergyHeight(val)
			end,
			get = function(info) return SliceCommander_Save.EnergyHeight end,
			isPercent = false
		},
		TimerHeight = {--Timer height
			order = 11,
			name = "Timer Height",
			desc = "TimerBar Height",
			type = "range",
			min = 1,
			max = 50,
			step = 1,
			bigStep = 1,
			set = function(info,val)
				SliceCommander_Save.TimerHeight = val
				SliceCommander:SetTimersHeight(val)
				SliceCommander:ApplySkin(SliceCommander_Save.skin)
			end,
			get = function(info) return SliceCommander_Save.TimerHeight end,
			isPercent = false
		},
		BarMargin = {--Margin
			order = 12,
			name = "Bar Margin",
			desc = "Bar Margin",
			type = "range",
			min = -2,
			max = 10,
			step = 1,
			bigStep = 1,
			set = function(info,val) SliceCommander_Save.BarMargin = val end,
			get = function(info) return SliceCommander_Save.BarMargin end,
			isPercent = false
		},
		FrameOpacity = {--Opacity
			order = 13,
			name = "Frame opacity",
			desc = "Frame opacity",
			type = "range",
			min = 25,
			max = 100,
			step = 1,
			bigStep = 1,
			set = function(info,val)
				SliceCommander:FrameOpacity(val)
				SliceCommander_Save.FrameOpacity = val
			end,
			get = function(info) return SliceCommander_Save.FrameOpacity end,
			isPercent = false
		},
		headerCheckHealth = {--Check health header
			order = 14,
			name = "Enable 35% backstab warning",
			type = "header"
		},
		checkHealthSpec1 = {--Check health spec1
			order = 15,
			name = "Spec 1",
			desc = "Check health for Spec 1",
			type = "toggle",
			set = function(info,val) SliceCommander_Save.checkHealthSpec1 = val end,
			get = function(info) return SliceCommander_Save.checkHealthSpec1 end
		},
		checkHealthSpec2 = {--Check health spec2
			order = 16,
			name = "Spec 2",
			desc = "Check health for Spec 2",
			type = "toggle",
			set = function(info,val) SliceCommander_Save.checkHealthSpec2 = val end,
			get = function(info) return SliceCommander_Save.checkHealthSpec2 end
		},
		HealthUnder = {--Texture
			order = 17,
			name = "Sound under 35% health",
			desc = "The sound play when the health reach 35% health",
			type = "select",
			values = function()
				returnArray = {}
				for ignore, SoundName in pairs(SliceCommander_SoundMenu['All']) do
					returnArray[SoundName] = SoundName
				end
				return returnArray
			end,
			set = function(info,val)
				SliceCommander:SoundTest(val)
				SliceCommander_Save.HealthUnder = val
			end,
			get = function(info)
				return SliceCommander_Save.HealthUnder
			end
		},
		headerKick = {
			order = 20,
			name = "Kick Feature",
			type = "header"
		},
		kickEnable = {
			order = 21,
			name = "Enable",
			desc = "If enable, a warning message will be display when you succeed to interrupts spellcasting.",
			type = "toggle",
			set = function(info,val) SliceCommander_Save.kickEnable = val end,
			get = function(info) return SliceCommander_Save.kickEnable end
		},
		kickMessage = {
			order = 22,
			name = "Warning message",
			desc = "The warning message which will be display when you kick is successful.",
			type = "input",
			width = "double",
			set = function(info,val) SliceCommander_Save.kickMessage = val end,
			get = function(info) return SliceCommander_Save.kickMessage end
		},
		headerSkin = {
			order = 30,
			name = "Kick Feature",
			type = "header"
		},
		skinEnable = {
			order = 31,
			name = "Enable",
			desc = "Add a border like the one on Tukui.",
			type = "toggle",
			set = function(info,val)
				SliceCommander_Save.skin = val
				SliceCommander:ApplySkin(val)
				SliceCommander:ShowHideBorder(val)
			end,
			get = function(info) return SliceCommander_Save.skin end
		},
	}
}

function SliceCommander:OnInitialize()
	_, englishClass = UnitClass("player")
	if englishClass == "ROGUE" then
		SliceCommander:RegisterEvent("UNIT_COMBO_POINTS")
		SliceCommander:RegisterEvent("PLAYER_TARGET_CHANGED")
		SliceCommander:RegisterEvent("UNIT_HEALTH")
		SliceCommander:RegisterEvent("PLAYER_LOGIN")
		SliceCommander:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	else
		SliceCommander:OnDisable()
		return 0
	end
end

function SliceCommander:PLAYER_LOGIN()
	SliceCommander:TestValueOptions()
	SliceCommander:InitBarArray()
	
	AceConfig:RegisterOptionsTable("SliceCommander", SC_OptionsTable)
	AceConfig:RegisterOptionsTable("SliceCommander_DisplayTimer", SC_OptionsTable_DisplayTimer)
	AceConfig:RegisterOptionsTable("SliceCommander_Sound", SC_OptionsTable_Sound)
	
	SetDefaultOpttion = AceConfigDialog:AddToBlizOptions("SliceCommander","SliceCommander")
	SetDefaultOpttion.default = function() SliceCommander:ResetOptions() end
	
	SetDefaultOpttion = AceConfigDialog:AddToBlizOptions("SliceCommander_DisplayTimer",SC_DISPLAY_SETTINGS,"SliceCommander")
	SetDefaultOpttion.default = function() SliceCommander:ResetOptions() end
	
	SetDefaultOpttion = AceConfigDialog:AddToBlizOptions("SliceCommander_Sound",SC_LANG_SOUND,"SliceCommander")
	SetDefaultOpttion.default = function() SliceCommander:ResetOptions() end
	
	SC.BarFont1 = SliceCommander:NewFont("VTimerFont", 17, 0.7, 1, 1, 1)
	SC.BarFont2 = SliceCommander:NewFont("VTimerFont2", 8, 0.7, 213/255, 200/255, 184/255)
	SC.BarFont3 = SliceCommander:NewFont("VTimerFont1O", 17, 0.2, 0, 0, 0)
	SC.BarFont4 = SliceCommander:NewFont("VTimerFont4", 8, 1, 213/255, 200/255, 184/255)
	
	SliceCommander:CreateCore()
	
	SC.LastEnergy = UnitMana('player')
	SC.curCombo = 0
	
	SC.OTHER['BG']['obj'] = SliceCommander:BGFrame()--create Bandit's Guile bar
	SC.BARS['CP']['obj'] = SliceCommander:CPFrame()--create Combot Point bar
	SC.BARS['KS']['obj'] = SliceCommander:NewFrame(227/255, 186/255, 132/255)--create Kidney Shot bar
	SC.BARS['CS']['obj'] = SliceCommander:NewFrame(227/255, 186/255, 132/255)--create Cheap Shot bar
	SC.BARS['SnD']['obj'] = SliceCommander:NewFrame(193/255, 79/255, 44/255)--create Slice and Dice bar
	SC.BARS['RUP']['obj'] = SliceCommander:NewFrame(180/255, 38/255, 38/255)--create Rupture bar
	SC.BARS['EA']['obj'] = SliceCommander:NewFrame(151/255, 101/255, 199/255)--create Expose Armor bar
	SC.BARS['GAR']['obj'] = SliceCommander:NewFrame(180/255, 38/255, 38/255)--create Garrote bar
	SC.BARS['REC']['obj'] = SliceCommander:NewFrame(110/255, 172/255, 163/255)--create Recuperate bar
	SC.BARS['VEN']['obj'] = SliceCommander:NewFrame(110/255, 34/255, 45/255)--create Vendetta bar
	SC.BARS['VENCD']['obj'] = SliceCommander:NewFrame(139/255, 78/255, 87/255)--create CD Vendetta bar
	SC.BARS['AR']['obj'] = SliceCommander:NewFrame(226/255, 130/255, 90/255)--create Adrenaline Rush bar
	SC.BARS['ARCD']['obj'] = SliceCommander:NewFrame(255/255, 173/255, 132/255)--create CD Adrenaline Rush bar
	SC.BARS['DP']['obj'] = SliceCommander:NewFrame(64/255, 167/255, 64/255)--create Deadly Poison bar
	SC.BARS['ENV']['obj'] = SliceCommander:NewFrame(64/255, 167/255, 64/255)--create Envenome bar
	SC.BARS['ToT']['obj'] = SliceCommander:NewFrame(77/255, 77/255, 255/255)--create Tricks of Trade bar
	SC.BARS['FE']['obj'] = SliceCommander:NewFrame(37/255, 108/255, 174/255)--create Feint bar
	SC.BARS['FECD']['obj'] = SliceCommander:NewFrame(37/255, 108/255, 174/255)--create Feint CD bar
	SC.BARS['THREAT']['obj'] = SliceCommander:NewFrame(0, 0, 0)
	
	SliceCommander:NewTickArray(SC.BARS['RUP'])--Create Ticks marker for Rupture Bar
	SliceCommander:NewTickArray(SC.BARS['GAR'])--Create Ticks marker for Garrote Bar
	SliceCommander:NewTickArray(SC.BARS['REC'])	--Create Ticks marker for Recuperate Bar	
	
	SC.OTHER['BF']['obj'] = SliceCommander:NewIcon("Interface\\Icons\\Ability_Warrior_PunishingBlow")--Create Blade fury icon display when BF is enable
	SC.OTHER['HEALTH']['obj'] = SliceCommander:NewIcon("Interface\\Icons\\Ability_BackStab")--Create Backstab icon display when Target is under 35% HP

	SC.BARS['VENCD']['obj'].icon:SetTexture("Interface\\Icons\\Ability_Rogue_Deadliness")
	SC.BARS['ARCD']['obj'].icon:SetTexture("Interface\\Icons\\Spell_Shadow_ShadowWordDominate")
	SC.BARS['ToT']['obj'].icon:SetTexture("Interface\\Icons\\Ability_Rogue_TricksOftheTrade")
	SC.BARS['FECD']['obj'].icon:SetTexture("Interface\\Icons\\ability_rogue_feint")
	
	SC.BARS['THREAT']['obj'].iconBackground:SetAlpha(0)--Hide icone for Threat bar
	for i,v in pairs(SC.BARS['THREAT']['obj'].iconBorder) do
		v:Hide()
	end
	SC.BARS['THREAT']['obj']:SetMinMaxValues(0, 110)--Threat value should be between 0 and 110
	
	SC.BARS['MH']['obj'] = SliceCommander:NewPoisonFrame("BOTTOMLEFT", "TOPLEFT", 0, -3*SC.V.pxH)--Create MH poison timer
	SC.BARS['OH']['obj'] = SliceCommander:NewPoisonFrame("TOPLEFT", "BOTTOMLEFT", 0 , 3*SC.V.pxH)--Create OH poison timer
	
	soundRup = {'RUP_Alert', 'RUP_Alert', 'RUP_Alert'}--Intilaise sounds array
	soundSnd = {'Tick1', 'Tick2', 'Tick3'}
	RUP_AlertPending = 3
	SND_AlertPending = 3
	print('|cffc14f2cSlice|r|cff40a740Commander|r v'..SC.VERSION)
	SliceCommander:ApplyConf()
	collectgarbage()
end

function SliceCommander:TestValueOptions()
	if SliceCommander_Save == nil or SliceCommander_Save.display == nil or SliceCommander_Save.Pos == nil then
		SliceCommander_Save = { display = {}, Pos = {} }
	end
	if SliceCommander_Save.ARSound == nil then
		SliceCommander_Save.ARSound = 'Mario'
	end
	if SliceCommander_Save.ARSound_Glyphed == nil then
		SliceCommander_Save.ARSound_Glyphed = 'Mario glyphed'
	end
	if SliceCommander_Save.IsLocked == nil then
		SliceCommander_Save.IsLocked = true
	end
	if SliceCommander_Save.HideEnergy == nil then
		SliceCommander_Save.HideEnergy = false
	end
	if SliceCommander_Save.Energy1 == nil then
		SliceCommander_Save.Energy1 = 35
	end
	if SliceCommander_Save.Energy2 == nil then
		SliceCommander_Save.Energy2 = 55
	end
	if SliceCommander_Save.Energy3 == nil then
		SliceCommander_Save.Energy3 = 25
	end
	if SliceCommander_Save.Fail == nil then
		SliceCommander_Save.Fail = 'None'
	end
	if SliceCommander_Save.Expire == nil then
		SliceCommander_Save.Expire = 'None'
	end
	if SliceCommander_Save.Tick3 == nil then
		SliceCommander_Save.Tick3 = 'None'
	end
	if SliceCommander_Save.Tick2 == nil then
		SliceCommander_Save.Tick2 = 'None'
	end
	if SliceCommander_Save.Tick1 == nil then
		SliceCommander_Save.Tick1 = 'None'
	end
	if SliceCommander_Save.Applied == nil then
		SliceCommander_Save.Applied = 'None'
	end
	if SliceCommander_Save.Apply3 == nil then
		SliceCommander_Save.Apply3 = 'None'
	end
	if SliceCommander_Save.Apply2 == nil then
		SliceCommander_Save.Apply2 = 'None'
	end
	if SliceCommander_Save.Apply1 == nil then
		SliceCommander_Save.Apply1 = 'None'
	end
	if SliceCommander_Save.EnergySound1 == nil then
		SliceCommander_Save.EnergySound1 = 'None'
	end
	if SliceCommander_Save.EnergySound2 == nil then
		SliceCommander_Save.EnergySound2 = 'None'
	end
	if SliceCommander_Save.EnergySound3 == nil then
		SliceCommander_Save.EnergySound3 = 'None'
	end
	if SliceCommander_Save.HealthUnder == nil then
		SliceCommander_Save.HealthUnder = 'You Spin Me'
	end
	if SliceCommander_Save.RUP_Fail == nil then
		SliceCommander_Save.RUP_Fail = 'None'
	end
	if SliceCommander_Save.RUP_Expire == nil then
		SliceCommander_Save.RUP_Expire = 'None'
	end
	if SliceCommander_Save.RUP_Applied == nil then
		SliceCommander_Save.RUP_Applied = 'None'
	end
	if SliceCommander_Save.RUP_Refresh3 == nil then
		SliceCommander_Save.RUP_Refresh3 = 'None'
	end
	if SliceCommander_Save.RUP_Refresh2 == nil then
		SliceCommander_Save.RUP_Refresh2 = 'None'
	end
	if SliceCommander_Save.RUP_Refresh1 == nil then
		SliceCommander_Save.RUP_Refresh1 = 'None'
	end
	if SliceCommander_Save.RUP_Alert == nil then
		SliceCommander_Save.RUP_Alert = 'None'
	end
	if SliceCommander_Save.Width == nil then
		SliceCommander_Save.Width = 279
	end
	if SliceCommander_Save.PadLatency == nil then
		SliceCommander_Save.PadLatency = true
	end
	if SliceCommander_Save.SpellText == nil then
		SliceCommander_Save.SpellText = true
	end
	if SliceCommander_Save.FullTimer == nil then
		SliceCommander_Save.FullTimer = false
	end
	if SliceCommander_Save.SoundCombat == nil then
		SliceCommander_Save.SoundCombat = true
	end
	if SliceCommander_Save.EnergyTrans == nil then
		SliceCommander_Save.EnergyTrans = 0
	end
	if SliceCommander_Save.BarMargin == nil then
		SliceCommander_Save.BarMargin = 7
	end
	if SliceCommander_Save.PoisonTransparencyShow == nil then
		SliceCommander_Save.PoisonTransparencyShow = true
	end
	if SliceCommander_Save.checkHealthSpec1 == nil then
		SliceCommander_Save.checkHealthSpec1 = true
	end
	if SliceCommander_Save.checkHealthSpec2 == nil then
		SliceCommander_Save.checkHealthSpec2 = true
	end
	if SliceCommander_Save.ThreatGroupOnly == nil then
		SliceCommander_Save.ThreatGroupOnly = true
	end
	if SliceCommander_Save.EnergyHeight == nil then
		SliceCommander_Save.EnergyHeight = 28
	end
	if SliceCommander_Save.TimerHeight == nil then
		SliceCommander_Save.TimerHeight = 17
	end
	if SliceCommander_Save.BarTexture == nil then
		SliceCommander_Save.BarTexture = 'Blizzard'	
	end
	if SliceCommander_Save.display.CP == nil then
		SliceCommander_Save.display.CP = true
	end
	if SliceCommander_Save.display.Poison == nil then
		SliceCommander_Save.display.Poison = true
	end
	if SliceCommander_Save.display.DP == nil then
		SliceCommander_Save.display.DP = false
	end
	if SliceCommander_Save.display.ENV == nil then
		SliceCommander_Save.display.ENV = true
	end
	if SliceCommander_Save.display.EA == nil then
		SliceCommander_Save.display.EA = true
	end
	if SliceCommander_Save.display.SnD == nil then
		SliceCommander_Save.display.SnD = true
	end
	if SliceCommander_Save.display.VEN == nil then
		SliceCommander_Save.display.VEN = true
	end
	if SliceCommander_Save.display.VENCD == nil then
		SliceCommander_Save.display.VENCD = true
	end
	if SliceCommander_Save.display.REC == nil then
		SliceCommander_Save.display.REC = true
	end
	if SliceCommander_Save.display.KS == nil then
		SliceCommander_Save.display.KS = true
	end
	if SliceCommander_Save.display.CS == nil then
		SliceCommander_Save.display.CS = true
	end
	if SliceCommander_Save.display.ToT == nil then
		SliceCommander_Save.display.ToT = true
	end
	if SliceCommander_Save.display.RUP == nil then
		SliceCommander_Save.display.RUP = true
	end
	if SliceCommander_Save.display.GAR == nil then
		SliceCommander_Save.display.GAR = true
	end
	if SliceCommander_Save.display.THREAT == nil then
		SliceCommander_Save.display.THREAT = true
	end
	if SliceCommander_Save.display.AR == nil then
		SliceCommander_Save.display.AR = true
	end
	if SliceCommander_Save.display.ARCD == nil then
		SliceCommander_Save.display.ARCD = true
	end
	if SliceCommander_Save.display.BF == nil then
		SliceCommander_Save.display.BF = true
	end
	if SliceCommander_Save.display.FE == nil then
		SliceCommander_Save.display.FE = true
	end
	if SliceCommander_Save.Pos.CP == nil then
		SliceCommander_Save.Pos.CP = -1
	end
	if SliceCommander_Save.Pos.THREAT == nil then
		SliceCommander_Save.Pos.THREAT = -2
	end
	if SliceCommander_Save.Pos.CS == nil then
		SliceCommander_Save.Pos.CS = -3
	end
	if SliceCommander_Save.Pos.KS == nil then
		SliceCommander_Save.Pos.KS = -4
	end
	if SliceCommander_Save.Pos.REC == nil then
		SliceCommander_Save.Pos.REC = 1
	end
	if SliceCommander_Save.Pos.SnD == nil then
		SliceCommander_Save.Pos.SnD = 2
	end
	if SliceCommander_Save.Pos.RUP == nil then
		SliceCommander_Save.Pos.RUP = 3
	end
	if SliceCommander_Save.Pos.GAR == nil then
		SliceCommander_Save.Pos.GAR = 4
	end
	if SliceCommander_Save.Pos.ToT == nil then
		SliceCommander_Save.Pos.ToT = 5
	end
	if SliceCommander_Save.Pos.VEN == nil then
		SliceCommander_Save.Pos.VEN = 6
	end
	if SliceCommander_Save.Pos.VENCD == nil then
		SliceCommander_Save.Pos.VENCD = 6
	end
	if SliceCommander_Save.Pos.DP == nil then
		SliceCommander_Save.Pos.DP = 7
	end
	if SliceCommander_Save.Pos.ENV == nil then
		SliceCommander_Save.Pos.ENV = 8
	end
	if SliceCommander_Save.Pos.AR == nil then
		SliceCommander_Save.Pos.AR = 9
	end
	if SliceCommander_Save.Pos.ARCD == nil then
		SliceCommander_Save.Pos.ARCD = 9
	end
	if SliceCommander_Save.Pos.EA == nil then
		SliceCommander_Save.Pos.EA = 10
	end
	if SliceCommander_Save.Pos.FE == nil then
		SliceCommander_Save.Pos.FE = 11
	end
	if SliceCommander_Save.Pos.FECD == nil then
		SliceCommander_Save.Pos.FECD = 11
	end
	if SliceCommander_Save.FrameOpacity == nil then
		SliceCommander_Save.FrameOpacity = 100
	end
	if SliceCommander_Save.ARMarioMod == nil then
		SliceCommander_Save.ARMarioMod = false
	end
	if SliceCommander_Save.kickEnable == nil then
		SliceCommander_Save.kickEnable = true
	end
	if SliceCommander_Save.kickMessage == nil then
		SliceCommander_Save.kickMessage = "Kick successful"
	end
	if SliceCommander_Save.point == nil then
		SliceCommander_Save.point = "TOP"
	end
	if SliceCommander_Save.relativeTo == nil then
		SliceCommander_Save.relativeTo = "UIParent"
	end
	if SliceCommander_Save.relativePoint == nil then
		SliceCommander_Save.relativePoint = "TOP"
	end
	if SliceCommander_Save.xOfs == nil then
		SliceCommander_Save.xOfs = 0
	end
	if SliceCommander_Save.yOfs == nil then
		SliceCommander_Save.yOfs = -300
	end
	if SliceCommander_Save.skin == nil then
		SliceCommander_Save.skin = true
	end
	if SliceCommander_Save.eyefinity == nil then
		SliceCommander_Save.eyefinity = 1
	end
end

function SliceCommander:ResetOptions()
	SliceCommander_Save = nil
	SliceCommander:TestValueOptions()
	if SC.BARS['SnD']['obj'] ~= 0 then
		SliceCommander:ApplyConf()
		LibStub("AceConfigRegistry-3.0"):NotifyChange("SliceCommander")
	end
end

function SliceCommander:ShowHideBorder(visible)
	if visible then
		for i,v in pairs(VTimerEnergy.border) do
			v:Show()
		end
		for i,v in pairs(SC.BARS) do
			if i ~= "MH" and i ~= "OH" then
				for j,w in pairs(v['obj'].border) do
					w:Show()
				end
				if i ~= "THREAT" and i ~= "CP" then
					for j,w in pairs(v['obj'].iconBorder) do
						w:Show()
					end
				end
			end
		end
	else
		for i,v in pairs(VTimerEnergy.border) do
			v:Hide()
		end
		for i,v in pairs(SC.BARS) do
			if i ~= "MH" and i ~= "OH" then
				for j,w in pairs(v['obj'].border) do
					w:Hide()
				end
				if i ~= "THREAT" and i ~= "CP" then
					for j,w in pairs(v['obj'].iconBorder) do
						w:Hide()
					end
				end
			end
		end
	end
end

function SliceCommander:ApplyConf()
	SliceCommander:LockCkecked(SliceCommander_Save.IsLocked)
	SliceCommander:SetTimersHeight(SliceCommander_Save.TimerHeight)
	SliceCommander:SetWidth(SliceCommander_Save.Width)
	SliceCommander:SetEnergyHeight(SliceCommander_Save.EnergyHeight)
	SliceCommander:Config_RetextureBars(SliceCommander:BarTexture())
	SliceCommander:FrameOpacity(SliceCommander_Save.FrameOpacity)
	SliceCommander:SetPoisonTransparency(SliceCommander_Save.EnergyTrans)
	SliceCommander:ApplySkin(SliceCommander_Save.skin)
	SliceCommander:ShowHideBorder(SliceCommander_Save.skin)
end

function SliceCommander:ConfigSoundMenuInit(WhichMenu)
	returnArray = {}
	for ignore, SoundName in pairs(SliceCommander_SoundMenu[WhichMenu]) do
		returnArray[SoundName] = SoundName
	end
	return returnArray
end

function SliceCommander:Config_OtherVars()
	SliceCommander_Spark[1]:SetPoint("TOPLEFT", VTimerEnergy, "TOPLEFT", ((SliceCommander_Save.Energy1 / UnitManaMax("player") * SliceCommander_Save.Width)-1)*SC.V.pxW, 0)
	SliceCommander_Spark[2]:SetPoint("TOPLEFT", VTimerEnergy, "TOPLEFT", ((SliceCommander_Save.Energy2 / UnitManaMax("player") * SliceCommander_Save.Width)-1)*SC.V.pxW, 0)
	SliceCommander_Spark[3]:SetPoint("TOPLEFT", VTimerEnergy, "TOPLEFT", ((SliceCommander_Save.Energy3 / UnitManaMax("player") * SliceCommander_Save.Width)-1)*SC.V.pxW, 0)
end

function SliceCommander:LockCkecked(checked)
	if checked then
		SliceCommander:SetPoisonTransparency(SliceCommander_Save.FrameOpacity)
		SliceCommanderFrame:SetAlpha(0)
		SliceCommanderFrame:EnableMouse(false)
		SliceCommander_Save.IsLocked = true
	else
		SliceCommander:SetPoisonTransparency(100)
		SliceCommanderFrame:SetAlpha(.5)
		SliceCommanderFrame:EnableMouse(true)
		SliceCommander_Save.IsLocked = false
	end	
end

function SliceCommander:Config_RetextureBars(texture)
	VTimerEnergy:SetStatusBarTexture(texture)
	for i,v in pairs(SC.BARS) do
		if v['expire'] ~= nil and i ~= 'CP' then
			v['obj']:SetStatusBarTexture(texture)
		end
	end
	
	for i = 1, 5 do
		SC.BARS['CP']['obj'].combos[i].bg:SetTexture(texture)
	end
end

function SliceCommander:SetWidth(w)
	h = SC.BARS['RUP']['obj'].iconBackground:GetHeight()/SC.V.pxH
	for i,v in pairs(SC.BARS) do
		if v['expire'] ~= nil and i ~= 'THREAT' and i ~= 'CP' then
			difW = (w-h-1) - v['obj']:GetWidth()/SC.V.pxW
			v['obj']:SetWidth((w-h-1)*SC.V.pxW)
			
			if i ~= 'MH' and i ~= 'OH' then
				for y,w in pairs(v['obj'].border) do
					w:SetWidth(w:GetWidth()+difW*SC.V.pxW)
				end
			end
		end
	end
	difW = h-VTimerEnergy:GetWidth()/SC.V.pxW
	for i,v in pairs(VTimerEnergy.border) do
		v:SetWidth(v:GetWidth()+difW*SC.V.pxW)
	end
	VTimerEnergy:SetWidth(w*SC.V.pxW)
	SC.BARS['MH']['obj']:SetWidth(w*SC.V.pxW)
	SC.BARS['OH']['obj']:SetWidth(w*SC.V.pxW)
	SC.BARS['CP']['obj']:SetWidth(w*SC.V.pxW)
	for i,v in pairs(SC.BARS['CP']['obj'].border) do
		v:SetWidth(v:GetWidth()+difW*SC.V.pxW)
	end
	SC.BARS['THREAT']['obj']:SetWidth(w*SC.V.pxW)
	for i,v in pairs(SC.BARS['THREAT']['obj'].border) do
		v:SetWidth(v:GetWidth()+difW*SC.V.pxW)
	end
	
	cx = 0
	widthCP = (((w-(2*4))/5))*SC.V.pxW
	for i = 1, 5 do
		SC.BARS['CP']['obj'].combos[i]:ClearAllPoints()
		SC.BARS['CP']['obj'].combos[i]:SetPoint("TOPLEFT", SC.BARS['CP']['obj'], "TOPLEFT", cx, 0)
		SC.BARS['CP']['obj'].combos[i]:SetPoint("BOTTOMRIGHT", SC.BARS['CP']['obj'], "BOTTOMLEFT", cx + widthCP , 0)
		cx = cx + widthCP + 2*SC.V.pxW
	end
	SliceCommander:Config_OtherVars()
end

function SliceCommander:SetSizeBorder(frame, border)
	k = 6
	for i,v in pairs(border) do
		v:SetHeight(frame:GetHeight()+k*SC.V.pxH)
		v:SetWidth(frame:GetWidth()+k*SC.V.pxW)
		k = k-2
	end
end

function SliceCommander:SetEnergyHeight(h)
	SliceCommanderFrame:SetWidth(h*SC.V.pxW)
	SliceCommanderFrame:SetHeight(h*SC.V.pxH)
	VTimerEnergy:SetHeight(h*SC.V.pxH)
	VTimerEnergyTxt:SetHeight(h*SC.V.pxH)
	SliceCommander_Combo:SetHeight(h*SC.V.pxH)
	SliceCommander_Spark[1]:SetHeight(h*SC.V.pxH)
	SliceCommander_Spark[2]:SetHeight(h*SC.V.pxH)
	SliceCommander_Spark[3]:SetHeight(h*SC.V.pxH)
	SliceCommander:SetSizeBorder(VTimerEnergy, VTimerEnergy.border)
end

function SliceCommander:SetTimersHeight(h)
	for i,v in pairs(SC.BARS) do
		if v['expire'] ~= nil and i ~= 'CP' and i ~= 'MH' and i ~= 'OH' then
			v['obj']:SetHeight(h*SC.V.pxH)
			v['obj'].text:SetHeight(h*SC.V.pxH)
			v['obj'].text2:SetHeight(h*SC.V.pxH)
			v['obj'].icon:SetHeight(h*SC.V.pxH)
			v['obj'].icon:SetWidth(h*SC.V.pxW)
			v['obj'].iconBackground:SetHeight((h+2)*SC.V.pxH)
			v['obj'].iconBackground:SetWidth((h+2)*SC.V.pxW)
			
			SliceCommander:SetSizeBorder(v['obj'], v['obj'].border)
			if i ~= 'THREAT' then
				SliceCommander:SetSizeBorder(v['obj'].icon, v['obj'].iconBorder)
			end
		end
	end
	
	for i = 1, 3 do
		SC.BARS['REC']['tick']['obj'][i]:SetHeight(h*SC.V.pxH)
	end
	for i = 1, 3 do
		SC.BARS['GAR']['tick']['obj'][i]:SetHeight(h*SC.V.pxH)
	end
	for i = 1, 3 do
		SC.BARS['RUP']['tick']['obj'][i]:SetHeight(h*SC.V.pxH)
	end
	SC.BARS['CP']['obj']:SetHeight(h*SC.V.pxH)
	SC.BARS['CP']['obj'].comboText:SetHeight(h*SC.V.pxH)
	for i = 1, 5 do
		SC.BARS['CP']['obj'].combos[i]:SetHeight((h-2)*SC.V.pxH)
	end
	SliceCommander:SetSizeBorder(SC.BARS['CP']['obj'], SC.BARS['CP']['obj'].border)
	
	SC.BarFont2:SetFont("Interface\\AddOns\\SliceCommander\\Fonts\\FRIZQT__.TTF", (h-2)*SC.V.pxH)
	SC.BarFont4:SetFont("Interface\\AddOns\\SliceCommander\\Fonts\\FRIZQT__.TTF", (h-2)*SC.V.pxH)
	SliceCommander:SetWidth(SliceCommander_Save.Width)
end

function SliceCommander:FrameOpacity(opValue)
	SliceCommander:SetPoisonTransparency(opValue)
	
	for i,v in pairs(SC.BARS) do
		if v['expire'] ~= nil then
			v['obj']:SetAlpha(opValue/100)
		end
	end
	
	SC.OTHER['BF']['obj']:SetAlpha(opValue/100)
	SC.OTHER['HEALTH']['obj']:SetAlpha(opValue/100)
end