﻿SliceCommander = LibStub("AceAddon-3.0"):NewAddon("SliceCommander", "AceEvent-3.0")
local self = SliceCommander

SC = { }
SC.VERSION = GetAddOnMetadata("SliceCommander", "Version")

function SliceCommander:InitBarArray()
	height = tonumber(string.match(GetCVar("gxResolution"), "%d+x(%d+)"))
	width = tonumber(string.match(GetCVar("gxResolution"), "(%d+)x+%d"))
	width = width*SliceCommander_Save.eyefinity--eyefinity is wird
	SC.V = {
		['bColor'] = {.1,.1,.1},
		['wColor'] = {.6,.6,.6},
		['pxH'] = UIParent:GetHeight() / height,
		['pxW'] = UIParent:GetWidth() / width
	}
	SC.OTHER = {
		['BG'] = {
			['obj'] = 0,
			['expire'] = 0
		},
		['BF'] = {
			['obj'] = 0
		},
		['HEALTH'] = {
			['obj'] = 0
		},
	}
	SC.BARS = {
		['THREAT'] = {
			['obj'] = 0,
			['expire'] = 0
		},
		['KS'] = {
			['obj'] = 0,
			['expire'] = 0,
			['name'] = SC_SPELL_KS,
			['type'] = 2
		},
		['CS'] = {
			['obj'] = 0,
			['expire'] = 0,
			['name'] = SC_SPELL_CS,
			['type'] = 2
		},
		['EA'] = {
			['obj'] = 0,
			['expire'] = 0,
			['name'] = SC_SPELL_EA,
			['type'] = 2
		},
		['CP'] = {
			['obj'] = 0,
			['expire'] = 0,
			['target'] = ''
		},
		['VEN'] = {
			['obj'] = 0,
			['expire'] = 0,
			['name'] = SC_SPELL_VEN,
			['type'] = 2
		},
		['VENCD'] = {
			['obj'] = 0,
			['expire'] = 0,
			['name'] = SC_SPELL_VEN,
			['type'] = 2
		},
		['ToT'] = {
			['obj'] = 0,
			['expire'] = 0,
			['name'] = SC_SPELL_TOT,
			['type'] = 1
		},
		['SnD'] = {
			['obj'] = 0,
			['expire'] = 0,
			['name'] = SC_SPELL_SND,
			['type'] = 1
		},
		['FE'] = {
			['obj'] = 0,
			['expire'] = 0,
			['name'] = SC_SPELL_FE,
			['type'] = 1
		},
		['FECD'] = {
			['obj'] = 0,
			['expire'] = 0,
			['name'] = SC_SPELL_FE,
			['type'] = 1
		},
		['DP'] = {
			['obj'] = 0,
			['expire'] = 0,
			['name'] = SC_SPELL_DP,
			['type'] = 2,
			['count'] = 0
		},
		['ENV'] = {
			['obj'] = 0,
			['expire'] = 0,
			['name'] = SC_SPELL_ENV,
			['type'] = 1
		},
		['REC'] = {
			['obj'] = 0,
			['expire'] = 0,
			['tick'] = {
				['obj'] = {},
				['expire'] = {}
			},
			['name'] = SC_SPELL_REC,
			['type'] = 1
		},
		['RUP'] = {
			['obj'] = 0,
			['expire'] = 0,
			['tick'] = {
				['obj'] = {},
				['expire'] = {},
				['value'] = 2
			},
			['name'] = SC_SPELL_RUP,
			['type'] = 2
		},
		['GAR'] = {
			['obj'] = 0,
			['expire'] = 0,
			['tick'] = {
				['obj'] = {},
				['expire'] = {},
				['value'] = 3
			},
			['name'] = SC_SPELL_GAR,
			['type'] = 2
		},
		['MH'] = {
			['obj'] = 0,
			['expire'] = 0
		},
		['OH'] = {
			['obj'] = 0,
			['expire'] = 0
		},
		['AR'] = {
			['obj'] = 0,
			['expire'] = 0,
			['name'] = SC_SPELL_AR,
			['type'] = 1,
		},
		['ARCD'] = {
			['obj'] = 0,
			['expire'] = 0,
			['name'] = SC_SPELL_AR,
			['type'] = 1,
		}
	}
end

function SliceCommander:MoveStart()
	if SliceCommander_Save.IsLocked == false then
		SliceCommanderFrame:StartMoving()
	end
end

function SliceCommander:MoveStop()
	if SliceCommander_Save.IsLocked == false then
		SliceCommanderFrame:StopMovingOrSizing()
		SliceCommanderFrame:SetUserPlaced(false)
		SliceCommander_Save.point, SliceCommander_Save.relativeTo, SliceCommander_Save.relativePoint, SliceCommander_Save.xOfs, SliceCommander_Save.yOfs = SliceCommanderFrame:GetPoint()
	end		
end

function SliceCommander:BarTexture() 
	if SliceCommander_Save.BarTexture then
		return SliceCommander_BarTextures[SliceCommander_Save.BarTexture]
	else
		return "Interface\\AddOns\\SliceCommander\\Images\\Smooth.tga"
	end
	
end

function SliceCommander:SoundTest(name) 
	if SliceCommander_Sounds[name] and SliceCommander_Sounds[name] ~= "" and SliceCommander_Sounds[name] ~= nil then
		PlaySoundFile( SliceCommander_Sounds[name], "Master")
	end
end

function SliceCommander:Sound(saved) 
	if isCombat()==1 then
		if SliceCommander_Save[saved] then
			if SliceCommander_Sounds[SliceCommander_Save[saved]] ~= "" and SliceCommander_Sounds[SliceCommander_Save[saved]] ~= nil then
				PlaySoundFile( SliceCommander_Sounds[SliceCommander_Save[saved]], "Master" )
			end
		end
	end
end

function SliceCommander:ChangeAnchor()
	offSetSize = SliceCommander_Save.BarMargin*SC.V.pxH -- other good values, -1, -2
	LastAnchorNeg = VTimerEnergy
	AnchorFromNeg = "BOTTOMRIGHT"
	AnchorToNeg = "TOPRIGHT"
	LastAnchorPos = VTimerEnergy
	AnchorFromPos = "TOPRIGHT"
	AnchorToPos = "BOTTOMRIGHT"
	for i = 1, 15 do
		--under
		if SliceCommander_Save.Pos.KS == i and SC.BARS['KS']['expire'] ~= 0 then
			SC.BARS['KS']['obj']:ClearAllPoints()
			SC.BARS['KS']['obj']:SetPoint(AnchorFromPos, LastAnchorPos, AnchorToPos, 0, offSetSize*-1)
			LastAnchorPos = SC.BARS['KS']['obj']
		end
		if SliceCommander_Save.Pos.CS == i and SC.BARS['CS']['expire'] ~= 0 then
			SC.BARS['CS']['obj']:ClearAllPoints()
			SC.BARS['CS']['obj']:SetPoint(AnchorFromPos, LastAnchorPos, AnchorToPos, 0, offSetSize*-1)
			LastAnchorPos = SC.BARS['CS']['obj']
		end
		if SliceCommander_Save.Pos.CP == i and SC.BARS['CP']['expire'] ~= 0 then
			SC.BARS['CP']['obj']:ClearAllPoints()
			SC.BARS['CP']['obj']:SetPoint(AnchorFromPos, LastAnchorPos, AnchorToPos, 0, offSetSize*-1)
			LastAnchorPos = SC.BARS['CP']['obj']
		end
		if SliceCommander_Save.Pos.REC == i and SC.BARS['REC']['expire'] ~= 0 then
			SC.BARS['REC']['obj']:ClearAllPoints()
			SC.BARS['REC']['obj']:SetPoint(AnchorFromPos, LastAnchorPos, AnchorToPos, 0, offSetSize*-1)
			LastAnchorPos = SC.BARS['REC']['obj']
		end
		if SliceCommander_Save.Pos.SnD == i and SC.BARS['SnD']['expire'] ~= 0 then
			SC.BARS['SnD']['obj']:ClearAllPoints()
			SC.BARS['SnD']['obj']:SetPoint(AnchorFromPos, LastAnchorPos, AnchorToPos, 0, offSetSize*-1)
			LastAnchorPos = SC.BARS['SnD']['obj']
		end
		if SliceCommander_Save.Pos.RUP == i and SC.BARS['RUP']['expire'] ~= 0 then
			SC.BARS['RUP']['obj']:ClearAllPoints()
			SC.BARS['RUP']['obj']:SetPoint(AnchorFromPos, LastAnchorPos, AnchorToPos, 0, offSetSize*-1)
			LastAnchorPos = SC.BARS['RUP']['obj']
		end
		if SliceCommander_Save.Pos.GAR == i and SC.BARS['GAR']['expire'] ~= 0 then
			SC.BARS['GAR']['obj']:ClearAllPoints()
			SC.BARS['GAR']['obj']:SetPoint(AnchorFromPos, LastAnchorPos, AnchorToPos, 0, offSetSize*-1)
			LastAnchorPos = SC.BARS['GAR']['obj']
		end
		if SliceCommander_Save.Pos.ToT == i and SC.BARS['ToT']['expire'] ~= 0 then
			SC.BARS['ToT']['obj']:ClearAllPoints()
			SC.BARS['ToT']['obj']:SetPoint(AnchorFromPos, LastAnchorPos, AnchorToPos, 0, offSetSize*-1)
			LastAnchorPos = SC.BARS['ToT']['obj']
		end
		if SliceCommander_Save.Pos.VEN == i and SC.BARS['VEN']['expire'] ~= 0 then
			SC.BARS['VEN']['obj']:ClearAllPoints()
			SC.BARS['VEN']['obj']:SetPoint(AnchorFromPos, LastAnchorPos, AnchorToPos, 0, offSetSize*-1)
			LastAnchorPos = SC.BARS['VEN']['obj']
		end
		if SliceCommander_Save.Pos.VENCD == i and SC.BARS['VENCD']['expire'] ~= 0 then
			SC.BARS['VENCD']['obj']:ClearAllPoints()
			SC.BARS['VENCD']['obj']:SetPoint(AnchorFromPos, LastAnchorPos, AnchorToPos, 0, offSetSize*-1)
			LastAnchorPos = SC.BARS['VENCD']['obj']
		end
		if SliceCommander_Save.Pos.DP == i and SC.BARS['DP']['expire'] ~= 0 then
			SC.BARS['DP']['obj']:ClearAllPoints()
			SC.BARS['DP']['obj']:SetPoint(AnchorFromPos, LastAnchorPos, AnchorToPos, 0, offSetSize*-1)
			LastAnchorPos = SC.BARS['DP']['obj']
		end
		if SliceCommander_Save.Pos.ENV == i and SC.BARS['ENV']['expire'] ~= 0 then
			SC.BARS['ENV']['obj']:ClearAllPoints()
			SC.BARS['ENV']['obj']:SetPoint(AnchorFromPos, LastAnchorPos, AnchorToPos, 0, offSetSize*-1)
			LastAnchorPos = SC.BARS['ENV']['obj']
		end
		if SliceCommander_Save.Pos.THREAT == i and SC.BARS['THREAT']['expire'] ~= 0 then
			SC.BARS['THREAT']['obj']:ClearAllPoints()
			SC.BARS['THREAT']['obj']:SetPoint(AnchorFromPos, LastAnchorPos, AnchorToPos, 0, offSetSize*-1)
			LastAnchorPos = SC.BARS['THREAT']['obj']
		end
		if SliceCommander_Save.Pos.AR == i and SC.BARS['AR']['expire'] ~= 0 then
			SC.BARS['AR']['obj']:ClearAllPoints()
			SC.BARS['AR']['obj']:SetPoint(AnchorFromPos, LastAnchorPos, AnchorToPos, 0, offSetSize*-1)
			LastAnchorPos = SC.BARS['AR']['obj']
		end
		if SliceCommander_Save.Pos.ARCD == i and SC.BARS['ARCD']['expire'] ~= 0 then
			SC.BARS['ARCD']['obj']:ClearAllPoints()
			SC.BARS['ARCD']['obj']:SetPoint(AnchorFromPos, LastAnchorPos, AnchorToPos, 0, offSetSize*-1)
			LastAnchorPos = SC.BARS['ARCD']['obj']
		end
		if SliceCommander_Save.Pos.EA == i and SC.BARS['EA']['expire'] ~= 0 then
			SC.BARS['EA']['obj']:ClearAllPoints()
			SC.BARS['EA']['obj']:SetPoint(AnchorFromPos, LastAnchorPos, AnchorToPos, 0, offSetSize*-1)
			LastAnchorPos = SC.BARS['EA']['obj']
		end
		if SliceCommander_Save.Pos.FE == i and SC.BARS['FE']['expire'] ~= 0 then
			SC.BARS['FE']['obj']:ClearAllPoints()
			SC.BARS['FE']['obj']:SetPoint(AnchorFromPos, LastAnchorPos, AnchorToPos, 0, offSetSize*-1)
			LastAnchorPos = SC.BARS['FE']['obj']
		end
		if SliceCommander_Save.Pos.FECD == i and SC.BARS['FECD']['expire'] ~= 0 then
			SC.BARS['FECD']['obj']:ClearAllPoints()
			SC.BARS['FECD']['obj']:SetPoint(AnchorFromPos, LastAnchorPos, AnchorToPos, 0, offSetSize*-1)
			LastAnchorPos = SC.BARS['FECD']['obj']
		end
		
		--on top
		if SliceCommander_Save.Pos.KS == i*-1 and SC.BARS['KS']['expire'] ~= 0 then
			SC.BARS['KS']['obj']:ClearAllPoints()
			SC.BARS['KS']['obj']:SetPoint(AnchorFromNeg, LastAnchorNeg, AnchorToNeg, 0, offSetSize)
			LastAnchorNeg = SC.BARS['KS']['obj']
		end
		if SliceCommander_Save.Pos.CS == i*-1 and SC.BARS['CS']['expire'] ~= 0 then
			SC.BARS['CS']['obj']:ClearAllPoints()
			SC.BARS['CS']['obj']:SetPoint(AnchorFromNeg, LastAnchorNeg, AnchorToNeg, 0, offSetSize)
			LastAnchorNeg = SC.BARS['CS']['obj']
		end
		if SliceCommander_Save.Pos.CP == i*-1 and SC.BARS['CP']['expire'] ~= 0 then
			SC.BARS['CP']['obj']:ClearAllPoints()
			SC.BARS['CP']['obj']:SetPoint(AnchorFromNeg, LastAnchorNeg, AnchorToNeg, 0, offSetSize)
			LastAnchorNeg = SC.BARS['CP']['obj']
		end
		if SliceCommander_Save.Pos.REC == i*-1 and SC.BARS['REC']['expire'] ~= 0 then
			SC.BARS['REC']['obj']:ClearAllPoints()
			SC.BARS['REC']['obj']:SetPoint(AnchorFromNeg, LastAnchorNeg, AnchorToNeg, 0, offSetSize)
			LastAnchorNeg = SC.BARS['REC']['obj']
		end
		if SliceCommander_Save.Pos.SnD == i*-1 and SC.BARS['SnD']['expire'] ~= 0 then
			SC.BARS['SnD']['obj']:ClearAllPoints()
			SC.BARS['SnD']['obj']:SetPoint(AnchorFromNeg, LastAnchorNeg, AnchorToNeg, 0, offSetSize)
			LastAnchorNeg = SC.BARS['SnD']['obj']
		end
		if SliceCommander_Save.Pos.RUP == i*-1 and SC.BARS['RUP']['expire'] ~= 0 then
			SC.BARS['RUP']['obj']:ClearAllPoints()
			SC.BARS['RUP']['obj']:SetPoint(AnchorFromNeg, LastAnchorNeg, AnchorToNeg, 0, offSetSize)
			LastAnchorNeg = SC.BARS['RUP']['obj']
		end
		if SliceCommander_Save.Pos.GAR == i*-1 and SC.BARS['GAR']['expire'] ~= 0 then
			SC.BARS['GAR']['obj']:ClearAllPoints()
			SC.BARS['GAR']['obj']:SetPoint(AnchorFromNeg, LastAnchorNeg, AnchorToNeg, 0, offSetSize)
			LastAnchorNeg = SC.BARS['GAR']['obj']
		end
		if SliceCommander_Save.Pos.ToT == i*-1 and SC.BARS['ToT']['expire'] ~= 0 then
			SC.BARS['ToT']['obj']:ClearAllPoints()
			SC.BARS['ToT']['obj']:SetPoint(AnchorFromNeg, LastAnchorNeg, AnchorToNeg, 0, offSetSize)
			LastAnchorNeg = SC.BARS['ToT']['obj']
		end
		if SliceCommander_Save.Pos.VEN == i*-1 and SC.BARS['VEN']['expire'] ~= 0 then
			SC.BARS['VEN']['obj']:ClearAllPoints()
			SC.BARS['VEN']['obj']:SetPoint(AnchorFromNeg, LastAnchorNeg, AnchorToNeg, 0, offSetSize)
			LastAnchorNeg = SC.BARS['VEN']['obj']
		end
		if SliceCommander_Save.Pos.VENCD == i*-1 and SC.BARS['VENCD']['expire'] ~= 0 then
			SC.BARS['VENCD']['obj']:ClearAllPoints()
			SC.BARS['VENCD']['obj']:SetPoint(AnchorFromNeg, LastAnchorNeg, AnchorToNeg, 0, offSetSize)
			LastAnchorNeg = SC.BARS['VENCD']['obj']
		end
		if SliceCommander_Save.Pos.DP == i*-1 and SC.BARS['DP']['expire'] ~= 0 then
			SC.BARS['DP']['obj']:ClearAllPoints()
			SC.BARS['DP']['obj']:SetPoint(AnchorFromNeg, LastAnchorNeg, AnchorToNeg, 0, offSetSize)
			LastAnchorNeg = SC.BARS['DP']['obj']
		end
		if SliceCommander_Save.Pos.ENV == i*-1 and SC.BARS['ENV']['expire'] ~= 0 then
			SC.BARS['ENV']['obj']:ClearAllPoints()
			SC.BARS['ENV']['obj']:SetPoint(AnchorFromNeg, LastAnchorNeg, AnchorToNeg, 0, offSetSize)
			LastAnchorNeg = SC.BARS['ENV']['obj']
		end
		if SliceCommander_Save.Pos.THREAT == i*-1 and SC.BARS['THREAT']['expire'] ~= 0 then
			SC.BARS['THREAT']['obj']:ClearAllPoints()
			SC.BARS['THREAT']['obj']:SetPoint(AnchorFromNeg, LastAnchorNeg, AnchorToNeg, 0, offSetSize)
			LastAnchorNeg = SC.BARS['THREAT']['obj']
		end
		if SliceCommander_Save.Pos.AR == i*-1 and SC.BARS['AR']['expire'] ~= 0 then
			SC.BARS['AR']['obj']:ClearAllPoints()
			SC.BARS['AR']['obj']:SetPoint(AnchorFromNeg, LastAnchorNeg, AnchorToNeg, 0, offSetSize)
			LastAnchorNeg = SC.BARS['AR']['obj']
		end
		if SliceCommander_Save.Pos.ARCD == i*-1 and SC.BARS['ARCD']['expire'] ~= 0 then
			SC.BARS['ARCD']['obj']:ClearAllPoints()
			SC.BARS['ARCD']['obj']:SetPoint(AnchorFromNeg, LastAnchorNeg, AnchorToNeg, 0, offSetSize)
			LastAnchorNeg = SC.BARS['ARCD']['obj']
		end
		if SliceCommander_Save.Pos.EA == i*-1 and SC.BARS['EA']['expire'] ~= 0 then
			SC.BARS['EA']['obj']:ClearAllPoints()
			SC.BARS['EA']['obj']:SetPoint(AnchorFromNeg, LastAnchorNeg, AnchorToNeg, 0, offSetSize)
			LastAnchorNeg = SC.BARS['EA']['obj']
		end
		if SliceCommander_Save.Pos.FE == i*-1 and SC.BARS['FE']['expire'] ~= 0 then
			SC.BARS['FE']['obj']:ClearAllPoints()
			SC.BARS['FE']['obj']:SetPoint(AnchorFromNeg, LastAnchorNeg, AnchorToNeg, 0, offSetSize)
			LastAnchorNeg = SC.BARS['FE']['obj']
		end
		if SliceCommander_Save.Pos.FECD == i*-1 and SC.BARS['FECD']['expire'] ~= 0 then
			SC.BARS['FECD']['obj']:ClearAllPoints()
			SC.BARS['FECD']['obj']:SetPoint(AnchorFromNeg, LastAnchorNeg, AnchorToNeg, 0, offSetSize)
			LastAnchorNeg = SC.BARS['FECD']['obj']
		end
	end
end

function isCombat()
	if SliceCommander_Save.SoundCombat==true then
		if UnitAffectingCombat("player")==1 then
			return 1
		else
			return 0
		end
	else
		return 1
	end
end

function SliceCommander:COMBAT_LOG_EVENT_UNFILTERED(_, _, event, _, _, sourceName)
	if event == "SPELL_INTERRUPT" and sourceName == UnitName("player") and SliceCommander_Save.kickEnable == true then
		SendChatMessage(SliceCommander_Save.kickMessage ,"SAY")
	end
end

function SliceCommander:UNIT_COMBO_POINTS(eventName, unit)
	if unit == "player" then
		SC.BARS['CP']['target'] = UnitGUID("target")
		SliceCommander:TestDPCP()
		SliceCommander:SetComboPts()
		SliceCommander:ChangeAnchor()
	end
end

function SliceCommander:PLAYER_TARGET_CHANGED(eventName, arg1)
	SC.OTHER['HEALTH']['obj']:Hide()
	SliceCommander:TestDPCP()
	SliceCommander:SetComboPts()
	SliceCommander:ChangeAnchor()
end

function SliceCommander:SetComboPts()
	points = GetComboPoints("player")
	if points == 0 then
		if UnitGUID("target") ~= SC.BARS['CP']['target'] then
			return
		end
	end
	
	SliceCommander_Combo:SetText("")
	SC.BARS['CP']['obj'].comboText:SetText("")
	for i = 1, 5 do
		SC.BARS['CP']['obj'].combos[i]:Hide()
	end
	SC.BARS['CP']['obj']:Hide()
	SC.BARS['CP']['expire'] = 0
	
	if points ~= 0 then
		SliceCommander_Combo:SetText(points)
		if SliceCommander_Save.display.CP == true then
			SC.BARS['CP']['expire'] = points
			SC.BARS['CP']['obj'].comboText:SetText(points)
			for i = 1, points do
				SC.BARS['CP']['obj'].combos[i]:Show()
			end
			SC.BARS['CP']['obj']:Show()
			if points < 3 then
				SC.BarFont4:SetShadowColor(0,0,0, 1)
				SC.BarFont4:SetTextColor(213/255,200/255,184/255,1)
			else
				SC.BarFont4:SetShadowColor(0,0,0, 0)
				SC.BarFont4:SetTextColor(0,0,0, 1)
			end
		end
	end
end

function SliceCommander:OnDisable()
	SliceCommander:UnregisterAllEvents()
end

function SliceCommander:NewFrame(r, g, b)
	f = CreateFrame("StatusBar", nil, UIParent)
	
	f:SetStatusBarTexture(SliceCommander:BarTexture())
	f:SetValue(0)
	
	f:SetBackdrop({
		bgFile="Interface\\AddOns\\SliceCommander\\Images\\solid.tga",
		edgeFile="",
		tile=true, tileSize=1, edgeSize=0,
		insets={left=-1*SC.V.pxW, right=-1*SC.V.pxW, top=-1*SC.V.pxH, bottom=-1*SC.V.pxH}
	})
	f:SetBackdropBorderColor(unpack(SC.V.wColor))
	f:SetBackdropColor(unpack(SC.V.bColor))
	f:SetFrameStrata("MEDIUM")
	
	-- text on the right --			
	f.text = f:CreateFontString(nil, nil, "GameFontWhite")
	f.text:SetFontObject(SC.BarFont2)
	f.text:SetWidth(40*SC.V.pxW)
	f.text:SetPoint("TOPRIGHT", f, "TOPRIGHT", -5*SC.V.pxW, 0)
	f.text:SetJustifyH("RIGHT")
	
	f.iconBackground = f:CreateTexture(nil, "BACKGROUND")
	f.iconBackground:SetPoint("RIGHT", f, "LEFT", -2*SC.V.pxW, 0)
	f.iconBackground:SetTexture(unpack(SC.V.bColor))

	f.icon = f:CreateTexture(nil, "OVERLAY")
	f.icon:SetPoint("CENTER", f.iconBackground, "CENTER", 0, 0)
	f.icon:SetTexCoord(.08, .92, .08, .92)
	
	-- text on the left --
	f.text2 = f:CreateFontString(nil, nil, nil)
	f.text2:SetPoint("TOPLEFT", f, "TOPLEFT", 2*SC.V.pxW, 0)
	f.text2:SetFontObject(SC.BarFont2)
	f.text2:SetWidth(120*SC.V.pxW)
	f.text2:SetPoint("RIGHT", f, "RIGHT", 0, 0)
	f.text2:SetJustifyH("CENTER")
	
	f:SetStatusBarColor(r, g, b)
	f.border = SliceCommander:tukSkin(f, false)
	f.iconBorder = SliceCommander:tukSkin(f, f.icon)
	
	return f
	
end

function SliceCommander:CPFrame()
	f = CreateFrame("StatusBar", nil, UIParent)
	
	f.bg = f:CreateTexture(nil, "BACKGROUND")
	f.bg:SetPoint("TOPLEFT", f, "TOPLEFT", 0, 0)
	f.bg:SetPoint("BOTTOMRIGHT", f, "BOTTOMRIGHT", 0, 0)
	f:SetBackdrop({
		bgFile="Interface\\AddOns\\SliceCommander\\Images\\solid.tga",
		edgeFile="",
		tile=false, tileSize=1, edgeSize=0,
		insets={left=-1*SC.V.pxW, right=-1*SC.V.pxW, top=-1*SC.V.pxH, bottom=-1*SC.V.pxH}
	})
	f:SetBackdropBorderColor(unpack(SC.V.wColor))
	f:SetBackdropColor(unpack(SC.V.bColor))
	f:SetFrameStrata("MEDIUM")
	
	f.combos = {}
	
	for i = 1, 5 do
		combo = CreateFrame("Frame", nil, f)
		combo.bg = combo:CreateTexture(nil, "BACKGROUND")
		combo.bg:SetAllPoints(combo)
		combo.bg:SetTexture("Interface\\AddOns\\SliceCommander\\Images\\solid.tga")
		combo:Hide()
		f.combos[i] = combo
	end

	f.overlay = CreateFrame("Frame", nil, f)
	f.overlay:SetAllPoints(f)
	
	f.comboText = f.overlay:CreateFontString(nil, "OVERLAY")
	f.comboText:SetFontObject(SC.BarFont4)
	f.comboText:SetWidth(120*SC.V.pxW)
	f.comboText:SetJustifyH("CENTER")
	f.comboText:SetAllPoints(f.overlay)
	
	f.border = SliceCommander:tukSkin(f, false)
	
	f:Hide()
	return f
	
end

function SliceCommander:NewPoisonFrame(point, relativePoint, x, y)
	f = CreateFrame("StatusBar", nil, UIParent)	
	f:SetHeight(2*SC.V.pxH)
	f:SetFrameLevel(2)
	f:SetStatusBarTexture(SliceCommander:BarTexture())
	f:SetStatusBarColor(64/255, 167/255, 64/255)
	f:SetMinMaxValues(0, 3600*1000)
	f:SetFrameStrata("MEDIUM")
	f:Hide()	
	f:SetBackdrop({
		bgFile="Interface\\AddOns\\SliceCommander\\Images\\solid.tga",
		edgeFile="",
		tile=true, tileSize=1, edgeSize=0,
		insets={left=0, right=0, top=0, bottom=0}
	})
	r,v,b = unpack(SC.V.bColor)
	f:SetBackdropBorderColor(unpack(SC.V.wColor))
	f:SetBackdropColor(r,v,b,0)
	f:SetPoint(point, VTimerEnergy, relativePoint, x, y)
	return f
end

function SliceCommander:CreateCore()
	SliceCommanderFrame = CreateFrame('Frame', 'SliceCommanderFrame', UIParent)
	SliceCommanderFrame:SetToplevel(true)
	SliceCommanderFrame:EnableMouse(false)
	SliceCommanderFrame:SetMovable(true)
	SliceCommanderFrame:SetWidth(28*SC.V.pxW)
	SliceCommanderFrame:SetHeight(28*SC.V.pxH)
	SliceCommanderFrame:SetPoint(SliceCommander_Save.point, SliceCommander_Save.relativeTo, SliceCommander_Save.relativePoint, SliceCommander_Save.xOfs, SliceCommander_Save.yOfs)
	SliceCommanderFrame:SetBackdrop({
		bgFile="Interface\\AddOns\\SliceCommander\\Images\\solid.tga",
		edgeFile="",
		tile=true, tileSize=1, edgeSize=0,
		insets={left=-1*SC.V.pxW, right=-1*SC.V.pxW, top=-1*SC.V.pxH, bottom=-1*SC.V.pxH}
	})
	SliceCommanderFrame:SetBackdropColor(0.7,0.2,0.2,1)
	SliceCommanderFrame:SetScript("OnMouseDown",function () SliceCommander:MoveStart() end)
	SliceCommanderFrame:SetScript("OnMouseUp",function () SliceCommander:MoveStop() end)
	SliceCommanderFrame:SetScript("OnUpdate",function () SliceCommander:OnUpdate() end)
	
	VTimerEnergy = CreateFrame('StatusBar', 'VTimerEnergy', UIParent)
	VTimerEnergy:SetSize(200*SC.V.pxW,20*SC.V.pxH)
	VTimerEnergy:SetMinMaxValues(0,100)
	VTimerEnergy:SetPoint('TOPLEFT', SliceCommanderFrame, 'TOPRIGHT', 0, 0)
	VTimerEnergy:SetFrameLevel(1)
	VTimerEnergy:SetMinMaxValues(0,UnitManaMax("player"))
	VTimerEnergy:SetBackdrop({
		bgFile="Interface\\AddOns\\SliceCommander\\Images\\solid.tga",
		edgeFile="",
		tile=true, tileSize=1, edgeSize=0,
		insets={left=-1*SC.V.pxW, right=-1*SC.V.pxW, top=-1*SC.V.pxH, bottom=-1*SC.V.pxH}
	})
	VTimerEnergy:SetBackdropBorderColor(unpack(SC.V.wColor))
	VTimerEnergy:SetBackdropColor(unpack(SC.V.bColor))
	VTimerEnergy:SetStatusBarTexture(SliceCommander:BarTexture())
	VTimerEnergy:SetFrameStrata("MEDIUM")
	VTimerEnergy:SetFrameLevel(1)
	VTimerEnergy:SetStatusBarColor(234/255, 234/255, 234/255)
	if SliceCommander_Save.HideEnergy then
		VTimerEnergy:Hide()
	else
		VTimerEnergy:Show()
	end
	
	VTimerEnergy.border = SliceCommander:tukSkin(VTimerEnergy, false)
	--VTimerEnergy.border = { }
	
	VTimerEnergyTxt = VTimerEnergy:CreateFontString('VTimerEnergyTxt', 'OVERLAY', GameFontWhite)
	VTimerEnergyTxt:SetJustifyH("RIGHT")
	VTimerEnergyTxt:SetSize(49*SC.V.pxW,20*SC.V.pxH)
	VTimerEnergyTxt:SetPoint('RIGHT', VTimerEnergy, 'RIGHT', -5*SC.V.pxW, 0)
	VTimerEnergyTxt:SetFontObject(SC.BarFont1)
	
	SliceCommander_Combo = VTimerEnergy:CreateFontString('SliceCommander_Combo', 'OVERLAY', GameFontWhite)
	SliceCommander_Combo:SetJustifyH("LEFT")
	SliceCommander_Combo:SetSize(20*SC.V.pxW,20*SC.V.pxH)
	SliceCommander_Combo:SetPoint('TOPLEFT', VTimerEnergy, 'TOPLEFT', 5*SC.V.pxW, 0)
	SliceCommander_Combo:SetFontObject(SC.BarFont3)
	
	SliceCommander_Spark = {}
	for i = 1, 3 do
		SliceCommander_Spark[i] = VTimerEnergy:CreateTexture(nil, 'OVERLAY', GameFontWhite)
		SliceCommander_Spark[i]:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
		SliceCommander_Spark[i]:SetBlendMode('ADD')
		SliceCommander_Spark[i]:SetSize(5*SC.V.pxW,20*SC.V.pxH)
	end
end

function SliceCommander:NewTickArray(BAR)
	for i = 1, 3 do
		BAR['tick']['obj'][i] = BAR['obj']:CreateTexture('SliceCommander_Spark3', 'OVERLAY', GameFontWhite)
		BAR['tick']['obj'][i]:SetTexture('Interface\\AddOns\\SliceCommander\\Images\\solid.tga')
		BAR['tick']['obj'][i]:SetWidth(1*SC.V.pxW)
		BAR['tick']['obj'][i]:SetVertexColor(226/255, 226/255, 226/255, 0.75)
	end
end

function SliceCommander:NewIcon(icon)
	f = CreateFrame("Frame",nil,VTimerEnergy)
	f:SetPoint("RIGHT", VTimerEnergy, "RIGHT", -50*SC.V.pxW, 0)
	f:SetFrameStrata("HIGH")
	f:SetSize(20*SC.V.pxW, 20*SC.V.pxH) 
	f:Hide()
	fIcon = f:CreateTexture(nil, "OVERLAY")
	fIcon:SetSize(20*SC.V.pxW, 20*SC.V.pxH) 
	fIcon:SetPoint("RIGHT", f, "RIGHT", 0, 0)
	fIcon:SetAlpha(1)
	fIcon:SetTexCoord(.08, .92, .08, .92)
	fIcon:SetTexture(icon)
	f.border = SliceCommander:tukSkin(f, fIcon)
	
	for i,v in pairs(f.border) do
		v:SetFrameStrata("MEDIUM")
		v:SetFrameLevel(i+1)
	end
	
	return f
end

function SliceCommander:NewFont(name, FontSize, aShadow, rColor, gColor, bColor)
	f = CreateFont(name)
	f:SetFont("Interface\\AddOns\\SliceCommander\\Fonts\\FRIZQT__.TTF", FontSize)
	f:SetShadowColor(0, 0, 0, aShadow)
	f:SetTextColor(rColor, gColor, bColor, 1)
	f:SetShadowOffset(0.8, -0.8)
	
	return f
end

function SliceCommander:BGFrame()
	f = CreateFrame("Frame",nil,UIParent)
	f:SetPoint("LEFT", VTimerEnergy, "LEFT", 20*SC.V.pxW, 0)
	f:SetFrameStrata("HIGH")
	f:SetWidth(40*SC.V.pxW)
	f:SetHeight(16*SC.V.pxH)
	f:Show()
	
	returnArray = { }
	x = 0
	for i = 1,3 do 
		returnArray[i] = f:CreateTexture(nil, "OVERLAY")
		returnArray[i]:SetHeight(16*SC.V.pxH)
		returnArray[i]:SetWidth(16*SC.V.pxW)
		returnArray[i]:SetPoint("LEFT", f, "LEFT", x, 0)
		returnArray[i]:SetAlpha(1)
		returnArray[i]:Hide()
		x = x + 12*SC.V.pxW
	end
	
	returnArray[1]:SetTexture('Interface\\AddOns\\SliceCommander\\Images\\Green.tga')
	returnArray[2]:SetTexture('Interface\\AddOns\\SliceCommander\\Images\\Yellow.tga')
	returnArray[3]:SetTexture('Interface\\AddOns\\SliceCommander\\Images\\Red.tga')
	
	return returnArray
end

function SliceCommander:ApplySkin(isApply)
	if isApply then
		for i,v in pairs(SC.BARS) do
			if i ~= 'MH' and i ~= 'OH' then
				if i ~= 'THREAT' and i ~= 'CP' then
					v['obj'].iconBackground:ClearAllPoints()
					v['obj'].iconBackground:SetPoint("RIGHT", v['obj'], "LEFT", -6*SC.V.pxW, 0)
					v['obj']:SetWidth(v['obj']:GetWidth()-4*SC.V.pxW)
				end
				SliceCommander:SetSizeBorder(v['obj'], v['obj'].border)
				SliceCommander:SetSizeBorder(VTimerEnergy, VTimerEnergy.border)
			end
		end
	else
		for i,v in pairs(SC.BARS) do
			if i ~= 'MH' and i ~= 'OH' and i ~= 'THREAT' and i ~= 'CP' then
				v['obj'].iconBackground:ClearAllPoints()
				v['obj'].iconBackground:SetPoint("RIGHT", v['obj'], "LEFT", -2*SC.V.pxW, 0)
				v['obj']:SetWidth(v['obj']:GetWidth()+4*SC.V.pxW)
				SliceCommander:SetSizeBorder(v['obj'], v['obj'].border)
				SliceCommander:SetSizeBorder(VTimerEnergy, VTimerEnergy.border)
			end
		end
	end
end

function SliceCommander:CreateTextureSkin(frame, w, h, color, level, texture)
	t = CreateFrame('Frame', nil, frame)
	t:SetBackdrop({
		bgFile="Interface\\AddOns\\SliceCommander\\Images\\solid.tga",
		edgeFile="",
		tile=true, tileSize=1, edgeSize=0,
		insets={left=0, right=0, top=0, bottom=0}
	})
	t:SetFrameLevel(level)
	t:SetFrameStrata("LOW")
	--t:SetFrameStrata(level)
	t:SetBackdropColor(unpack(color))
	if texture then
		t:SetPoint("CENTER", texture, "CENTER", 0, 0)
		t:SetSize(texture:GetWidth()+w, texture:GetHeight()+h)
	else
		t:SetPoint("CENTER", frame, "CENTER", 0, 0)
		t:SetSize(frame:GetWidth()+w, frame:GetHeight()+h)
	end
	t:Show()
	
	return t
end

function SliceCommander:tukSkin(frame, texture)
	return {
		[1] = SliceCommander:CreateTextureSkin(frame, 6*SC.V.pxW, 6*SC.V.pxH, SC.V.bColor, 1, texture),
		[2] = SliceCommander:CreateTextureSkin(frame, 4*SC.V.pxW, 4*SC.V.pxH, SC.V.wColor, 2, texture),
		[3] = SliceCommander:CreateTextureSkin(frame, 2*SC.V.pxW, 2*SC.V.pxH, SC.V.bColor, 3, texture)
	}
end

function SliceCommander:AbilityCDBar(BAR, display)
	if display ~= true then
		if BAR['obj']:IsVisible() then
			SliceCommander:HideBar(BAR)
		end
		return
	end
	
	start, duration, enabled = GetSpellCooldown(BAR['name'])
	if start == nil or duration == nil or enabled == nil then--not in this spec
		if BAR['obj']:IsVisible()then--if you respect when a cd is enabled
			BAR['expire'] = 0
			SliceCommander:HideBar(BAR)
		end
		return
	end
	if start ~= 0 and duration > 2 and not BAR['obj']:IsVisible() and enabled == 1 then
		SliceCommander:EnableBar(BAR, duration, BAR['name'].." (CD)", (start+duration))
		return
	end
	if start == 0 and BAR['obj']:IsVisible()then
		BAR['expire'] = 0
		SliceCommander:HideBar(BAR)
		return
	end
	if start == 0 or duration < 2 or enabled ~= 1 then
		return
	end
	BAR['expire'] = (start+duration)
	if BAR['expire'] > 0 and SC.tNow < BAR['expire'] then
		x = BAR['expire'] - SC.tNow
	else
		x = 0
	end
	BAR['obj']:SetValue(x)
	BAR['obj'].text:SetText(string.format("%0.1f", x))
end

function SliceCommander:EnableBar(BAR, duration, text, expire)
	BAR['expire'] = expire
	if SliceCommander_Save.FullTimer == true then
		BAR['obj']:SetMinMaxValues(0, duration)
	else
		BAR['obj']:SetMinMaxValues(0, 6.0)
	end
	if SliceCommander_Save.SpellText == true then
		BAR['obj'].text2:SetText(string.format("%s", text))
	else
		BAR['obj'].text2:SetText("")
	end
	BAR['obj']:Show()
	SliceCommander:ChangeAnchor()
end

function SliceCommander:HideBar(BAR)
	BAR['obj'].text:SetText("")
	BAR['expire'] = 0
	SliceCommander:ChangeAnchor()
	BAR['obj']:Hide()
end

function SliceCommander:UpdateBar(BAR, display, soundTable, AlertPending, tick, soundTest)
	if display ~= true then
		SliceCommander:HideBar(BAR)
		return
	end

	last = BAR['expire']
	if BAR['type'] == 1 then
		_, rank, icon, _, _, duration, BAR['expire'], unitCaster = UnitAura("player", BAR['name'], nil, "PLAYER")
	else
		_, rank, icon, _, _, duration, BAR['expire'], unitCaster = UnitDebuff("target", BAR['name'], nil, "PLAYER")
	end
	
	if unitCaster ~= "player" and unitCaster ~= nil then
		BAR['expire'] = last
	end
	
	if BAR['expire'] == nil then
		BAR['expire'] = 0
	end
	if SC.tNow == nil then
		SC.tNow = GetTime()
	end
	if BAR['expire'] > 0 and SC.tNow < BAR['expire'] then
		x = BAR['expire'] - SC.tNow
	else
		x = 0
	end
	if x > 0 then
		if BAR['obj']:IsVisible() ~= 1 then
			BAR['obj'].icon:SetTexture(icon)
			SliceCommander:EnableBar(BAR, duration, BAR['name'], BAR['expire'])
		end
		BAR['obj']:SetValue(x)
		BAR['obj'].text:SetText(string.format("%0.1f", x))
		if tick ~= false then
			_, maxValue = BAR['obj']:GetMinMaxValues()
			widthSeconde = (BAR['obj']:GetWidth())/maxValue
			possible = 0
			value = (x % tick)
			if value == 0 then
				value = tick
			end
			for i = 1,3 do
				if value > x or value > maxValue then
					BAR['tick']['obj'][i]:Hide()
				else
					BAR['tick']['obj'][i]:Show()
					BAR['tick']['obj'][i]:SetPoint("LEFT", BAR['obj'], "LEFT", widthSeconde*value, 0)
					value = value+tick
				end
			end
		end
		
		if soundTest == 1 and BAR['expire'] > last then
			if last == 0 and BAR['expire'] > 0 then
				SliceCommander:Sound("Applied")
			else
				timeLeftOnLast = last - GetTime()
				if timeLeftOnLast <= 1 then
					SliceCommander:Sound("Apply1")
				else
					if timeLeftOnLast <= 2 then
						SliceCommander:Sound("Apply2")
					else
						SliceCommander:Sound("Apply3")
					end
				end
			end
		elseif soundTest == 2 and BAR['expire'] > last then
			if last == 0 and BAR['expire'] > 0 then
				SliceCommander:Sound("RUP_Applied")
			else
				timeLeftOnLast = last - GetTime()
				if timeLeftOnLast <= 1 then
					SliceCommander:Sound("RUP_Refresh1")
				else
					if timeLeftOnLast <= 2 then
						SliceCommander:Sound("RUP_Refresh2")
					else
						SliceCommander:Sound("RUP_Refresh3")
					end
				end
			end
		elseif soundTest == 3 and BAR['expire'] > last then
			if SliceCommander_Save.ARMarioMod then
				if duration > 16 then
					SliceCommander:Sound('ARSound_Glyphed')
				else
					SliceCommander:Sound('ARSound')
				end
			end
			BAR['cd'] = true
			BAR['obj']:SetStatusBarColor(226/255, 130/255, 90/255)
		end
	else
		if BAR['obj']:IsVisible() then
			if soundTest == 1 then
				if UnitAffectingCombat("player") then
					SliceCommander:Sound("Fail")
				else
					SliceCommander:Sound("Expire")
				end
			elseif soundTest == 2 then
				if UnitAffectingCombat("player") then
					SliceCommander:Sound("RUP_Fail")
				else
					SliceCommander:Sound("RUP_Expire")
				end
			end
		
			if tick ~= false then
				for i = 1,3 do
					BAR['tick']['expire'][i] = 0
				end
			end
			SliceCommander:HideBar(BAR)
		end
	end
	if AlertPending ~= nil then
		if x > 0 then
			if x <= 3 then
				if AlertPending == 3 then
					SliceCommander:Sound(soundTable[3])
					AlertPending = 2
				else 
					if x <= 2 then
						if AlertPending == 2 then
							SliceCommander:Sound(soundTable[2])
							AlertPending = 1
						else 
							if x <= 1 then
								if AlertPending == 1 then
									SliceCommander:Sound(soundTable[1])
									AlertPending = 0
								end
							end
						end
					end
				end
			else
				AlertPending = 3
			end
		end
		return AlertPending
	end
end

function SliceCommander:CPColor(name, count, isMine)
	nameUID = UnitGUID("target")
	if not nameUID then
		nameUID = UnitGUID("player")
	end
	for i = 1, 5 do
		if SC.BARS['CP']['target'] == nameUID then
			if name and isMine == "player" and i <= count then
				SC.BARS['CP']['obj'].combos[i].bg:SetVertexColor(64/255, 167/255, 64/255)--Green
			else
				SC.BARS['CP']['obj'].combos[i].bg:SetVertexColor(192/255, 176/255, 71/255)--Yellow
			end
		else
			SC.BARS['CP']['obj'].combos[i].bg:SetVertexColor(124/255, 124/255, 124/255)--Gray
		end
	end
end

function SliceCommander:PoisonBar()
	if SliceCommander_Save.display.Poison == true then
		_ , mainHandExpiration , _ , _ , offHandExpiration = GetWeaponEnchantInfo()
		if mainHandExpiration ~= nil then
			SC.BARS['MH']['obj']:SetValue(mainHandExpiration)
			SC.BARS['MH']['obj']:Show()
		else
			SC.BARS['MH']['obj']:Hide()
		end
		if offHandExpiration ~= nil then
			SC.BARS['OH']['obj']:SetValue(offHandExpiration)
			SC.BARS['OH']['obj']:Show()
		else
			SC.BARS['OH']['obj']:Hide()
		end
	else
		SC.BARS['MH']['obj']:Hide()
		SC.BARS['OH']['obj']:Hide()
	end
end

function SliceCommander:UNIT_HEALTH()
	if (GetActiveTalentGroup(false,false) == 1 and SliceCommander_Save.checkHealthSpec1)
		or (GetActiveTalentGroup(false,false) == 2 and SliceCommander_Save.checkHealthSpec2) then
		HP = UnitHealth("target")
		maxHP = UnitHealthMax("target")
		if HP ~= 0 and maxHP ~= 0 and not UnitIsFriend("player","target")then
			pourcentHP = (HP / maxHP) * 100
			if pourcentHP <= 35 then
				if not SC.OTHER['HEALTH']['obj']:IsVisible() then
					SliceCommander:Sound("HealthUnder")
					SC.OTHER['HEALTH']['obj']:Show()
				end
			else
				if SC.OTHER['HEALTH']['obj']:IsVisible() then
					SC.OTHER['HEALTH']['obj']:Hide()
				end
			end
		else
			if SC.OTHER['HEALTH']['obj']:IsVisible() then
				SC.OTHER['HEALTH']['obj']:Hide()
			end
		end
	end
end

function SliceCommander:TargetThreat()
	if SliceCommander_Save.display.THREAT == false or (SliceCommander_Save.ThreatGroupOnly and GetNumRaidMembers() == 0 and GetNumPartyMembers() == 0) then
		SC.BARS['THREAT']['expire'] = 0
	else
		isTanking, status, threatpct, rawthreatpct, threatvalue = UnitDetailedThreatSituation("player", "target")
		if rawthreatpct == nil then
			SC.BARS['THREAT']['expire'] = 0
		else
			hexCol = rawthreatpct *(255/110)
			rCol = hexCol-45
			gCol = 255-hexCol+50
			if isTanking == 1 then
				rCol = 210
				gCol = 50
				rawthreatpct = 100
			end
			if rCol > 210 then
				rCol = 210
			end
			if rCol < 50 then
				rCol = 50
			end	
			if gCol > 210 then
				gCol = 210
			end
			if gCol < 50 then
				gCol = 50
			end			
			bCol = 50
			SC.BARS['THREAT']['expire'] = rawthreatpct
		end
	end
	if SC.BARS['THREAT']['expire'] == 0 then
		SC.BARS['THREAT']['obj']:Hide()
	else
		SC.BARS['THREAT']['obj']:SetValue(SC.BARS['THREAT']['expire'])
		SC.BARS['THREAT']['obj'].text:SetText(string.format("%0.1f", SC.BARS['THREAT']['expire']))
		SC.BARS['THREAT']['obj']:SetStatusBarColor(rCol/255,gCol/255,bCol/255)
		SC.BARS['THREAT']['obj']:Show()
		SliceCommander:ChangeAnchor()
	end
end

function SliceCommander:SetPoisonTransparency(value)
	VTimerEnergy:SetAlpha(value/100)
	SC.BARS['MH']['obj']:SetAlpha(value/100)
	SC.BARS['OH']['obj']:SetAlpha(value/100)
end

function SliceCommander:TestBF()
	if SliceCommander_Save.display.BF then
		name = UnitAura("player", SC_SPELL_BF, nil, "PLAYER")
		if name and not SC.OTHER['BF']['obj']:IsVisible() then
			SC.OTHER['BF']['obj']:Show()
		elseif not name and SC.OTHER['BF']['obj']:IsVisible() then
			SC.OTHER['BF']['obj']:Hide()
		end
	else
		SC.OTHER['BF']['obj']:Hide()
	end
end

function SliceCommander:TestDPCP()
	name, _, _, count, _, _, _, isMine = UnitDebuff("target", SC_SPELL_DP, nil, "PLAYER")
	if count == nil then
		count = 0
	end
	SliceCommander:CPColor(name, count, isMine)
end

function SliceCommander:Latency()
	SC.tNow = GetTime()
	if (SliceCommander_Save.PadLatency) then
		_, _, SC.lag = GetNetStats()
		SC.tNow = SC.tNow + (SC.lag*2/1000)
	end
end

function SliceCommander:Energy()
	VTimerEnergy:SetValue(UnitMana("player"))
	VTimerEnergy:SetMinMaxValues(0,UnitManaMax("player"))
	VTimerEnergyTxt:SetText(VTimerEnergy:GetValue())
		
	if SC.LastEnergy < SliceCommander_Save.Energy2 and UnitMana('player') >= SliceCommander_Save.Energy2 then
		SliceCommander:Sound("EnergySound2")
	elseif SC.LastEnergy < SliceCommander_Save.Energy1 and UnitMana('player') >= SliceCommander_Save.Energy1 then
		SliceCommander:Sound("EnergySound1")
	elseif SC.LastEnergy < SliceCommander_Save.Energy3 and UnitMana('player') >= SliceCommander_Save.Energy3 then
		SliceCommander:Sound("EnergySound3")
	end
	SC.LastEnergy = UnitMana('player')
	
	if UnitManaMax("player") == UnitMana('player') and UnitAffectingCombat("player")~=1 then
		if SliceCommander_Save.display.Poison == true and SliceCommander_Save.PoisonTransparencyShow == true and ((SC.BARS['MH']['obj']:GetValue() ~= 0 and SC.BARS['MH']['obj']:GetValue() ~= nil) or (SC.BARS['OH']['obj']:GetValue() ~= 0 and SC.BARS['OH']['obj']:GetValue() ~= nil) ) then
			SliceCommander:SetPoisonTransparency(SliceCommander_Save.FrameOpacity)
		else
			SliceCommander:SetPoisonTransparency(SliceCommander_Save.EnergyTrans)
		end
	else
		SliceCommander:SetPoisonTransparency(SliceCommander_Save.FrameOpacity)
	end
end

function SliceCommander:BanditGuile()
	if UnitAura("player", SC_SPELL_BG1, nil, "PLAYER") then
		SC.OTHER['BG']['expire'] = 1
	elseif UnitAura("player", SC_SPELL_BG2, nil, "PLAYER") then
		SC.OTHER['BG']['expire'] = 2
	elseif UnitAura("player", SC_SPELL_BG3, nil, "PLAYER") then
		SC.OTHER['BG']['expire'] = 3
	else
		SC.OTHER['BG']['expire'] = 0
	end
	
	for i = 1, 3 do
		if i <= SC.OTHER['BG']['expire'] then
			SC.OTHER['BG']['obj'][i]:Show()
		else
			SC.OTHER['BG']['obj'][i]:Hide()
		end
	end
end

function SliceCommander:OnUpdate()
	SliceCommander:Energy()--Update energy value and play sound if necessary
	SliceCommander:Latency()--Update timer reference and latency
	
	SliceCommander:PoisonBar()--Update Poisons Bar
	SliceCommander:TargetThreat()--Update Threat Bar
	
	SliceCommander:BanditGuile()--Update Bandit's Guile indicator
	
	RUP_AlertPending = SliceCommander:UpdateBar(SC.BARS['RUP'], SliceCommander_Save.display.RUP, soundRup, RUP_AlertPending, 2, 2)--Update Rupture Bar	
	SND_AlertPending = SliceCommander:UpdateBar(SC.BARS['SnD'], SliceCommander_Save.display.SnD, soundSnd, SND_AlertPending, false, 1)--Update SnD Bar
	SliceCommander:UpdateBar(SC.BARS['REC'], SliceCommander_Save.display.REC, nil, nil, 3, 0)--Update Recuprate Bar
	SliceCommander:UpdateBar(SC.BARS['GAR'], SliceCommander_Save.display.GAR, nil, nil, 3, 0)--Update Garrote Bar
	SliceCommander:UpdateBar(SC.BARS['EA'], SliceCommander_Save.display.EA, nil, nil, false, 0)--Update Expose Armor Bar
	SliceCommander:UpdateBar(SC.BARS['FE'], SliceCommander_Save.display.FE, nil, nil, false, 0)--Update Feint Bar
	SliceCommander:UpdateBar(SC.BARS['KS'], SliceCommander_Save.display.KS, nil, nil, false, 0)--Update Kidney Shot Bar
	SliceCommander:UpdateBar(SC.BARS['CS'], SliceCommander_Save.display.CS, nil, nil, false, 0)--Update Cheap Shot Bar
	SliceCommander:UpdateBar(SC.BARS['DP'], SliceCommander_Save.display.DP, nil, nil, false, 0)--Update Deadly poison Bar
	SliceCommander:UpdateBar(SC.BARS['ENV'], SliceCommander_Save.display.ENV, nil, nil, false, 0)--Update Envenom Bar
	SliceCommander:UpdateBar(SC.BARS['VEN'], SliceCommander_Save.display.VEN, nil, nil, false, 0)--Update Vendetta Bar
	SliceCommander:UpdateBar(SC.BARS['AR'], SliceCommander_Save.display.AR, nil, nil, false, 3)--Update Adrenaline rush Bar
	SliceCommander:AbilityCDBar(SC.BARS['VENCD'], SliceCommander_Save.display.VENCD)--Update Vendetta CD bar
	SliceCommander:AbilityCDBar(SC.BARS['ToT'], SliceCommander_Save.display.ToT)--Update ToT CD bar
	SliceCommander:AbilityCDBar(SC.BARS['ARCD'], SliceCommander_Save.display.ARCD)--Update Adrenaline rush CD bar
	SliceCommander:AbilityCDBar(SC.BARS['FECD'], SliceCommander_Save.display.FE)--Update Feint CD bar
	SliceCommander:TestDPCP()--Update Combot point color
	SliceCommander:TestBF()--Update BF bar display
end

do
	SLASH_RELOADUI1 = "/rl"
	SlashCmdList.RELOADUI = ReloadUI
	
	SLASH_SLICECOMMANDER1 = "/slicecommander"
	SLASH_SLICECOMMANDER2 = "/sc"
	SlashCmdList["SLICECOMMANDER"] = function(msg, editbox)
		local command, rest = msg:match("^(%S*)%s*(.-)$")
		if command == "eyefinity" and tonumber(rest) then
			SliceCommander_Save.eyefinity = rest
			ReloadUI()
		else
			InterfaceOptionsFrame_OpenToCategory("SliceCommander")
		end
	end
end